﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.Windows.Forms;
using AccesDB;
using NegociEntitats;

namespace Negoci
{
    public class formatsCN
    {
        // Establim la connexió amb les classes que modelitzen la BD...
        DataClassesBibliotecaDataContext dc = new DataClassesBibliotecaDataContext();

        // ***********************************************************************************************
        //  Comprova si existeix un format
        public Boolean existeixFormat(string id_format)
        {
            try
            {
                var query = (from d in dc.formats
                             where d.id_format.Equals(id_format)
                             select d);

                if (query.Count() == 0) return false;
                return true;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error comprovant existencia format", MessageBoxButtons.OK, MessageBoxIcon.Error); return false;
            }
        }

        
        
        // ***********************************************************************************************
        //  Buscar el registre
        public formatsEntity buscarFormat(string id_format)
        {
            try
            {
                if (id_format != null)
                {
                    var query = (from d in dc.formats
                                 where d.id_format.Equals(id_format)
                                 select d).Single();
                    formatsEntity obj = new formatsEntity();
                    obj.id_format = query.id_format;
                    obj.format = query.format;
                    return obj;
                }
                else
                {
                    return null;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error buscar Formats", MessageBoxButtons.OK, MessageBoxIcon.Error); return null;
            }
        }

        // ***********************************************************************************************
        // Afegir registre...
        public void afegirFormat(formatsEntity formatAct)
        {
            try
            {

                formats obj = new formats();
                obj.id_format = formatAct.id_format;
                obj.format = formatAct.format;

                dc.formats.InsertOnSubmit(obj);
                dc.SubmitChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error afegint format", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }


        // ***********************************************************************************************
        // Modificar registre...
        public void modificarFormat(formatsEntity formatAct)
        {
            var obj = (from d in dc.formats
                       where d.id_format == formatAct.id_format
                       select d).Single();

            try
            {
                obj.id_format = formatAct.id_format;
                obj.format = formatAct.format;
                dc.SubmitChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error modificant format", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }


        // ***********************************************************************************************
        // Eliminar registre...
        public void eliminarFormat(string id_format)
        {
            try
            {
                var query = (from d in dc.formats
                             where d.id_format == id_format
                             select d).Single();
                dc.formats.DeleteOnSubmit(query);
                dc.SubmitChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error eliminant format", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }


        // ***********************************************************************************************
        //  Llistar els formats
        public List<formatsEntity> llistarFormats()
        {
            try
            {
                List<formatsEntity> llista = new List<formatsEntity>();
                var query = (from d in dc.formats
                                 where true
                                 select d);
                foreach (var d in query)
                {
                    formatsEntity obj = new formatsEntity();
                    obj.id_format = d.id_format;
                    obj.format = d.format;
                    llista.Add(obj);
                }
                return llista;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); return null;
            }
        }



    }//fi classe
}//fi namespace
