﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.Windows.Forms;
using AccesDB;
using NegociEntitats;

namespace Negoci
{
    public class idiomesCN
    {
        // Establim la connexió amb les classes que modelitzen la BD...
        DataClassesBibliotecaDataContext dc = new DataClassesBibliotecaDataContext();

        // ***********************************************************************************************
        //  Comprova si existeix un idioma
        public Boolean existeixIdioma(string id_idioma)
        {
            try
            {
                var query = (from d in dc.idiomes
                             where d.id_idioma.Equals(id_idioma)
                             select d);

                if (query.Count() == 0) return false;
                return true;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error comprovant existencia idioma", MessageBoxButtons.OK, MessageBoxIcon.Error); return false;
            }
        }
        
        
        // ***********************************************************************************************
        //  Buscar el registre
        public idiomesEntity buscarIdioma(string id_idioma)
        {
            try
            {
                if (id_idioma != null)
                {
                    var query = (from d in dc.idiomes
                                 where d.id_idioma.Equals(id_idioma)
                                 select d).Single();
                    idiomesEntity obj = new idiomesEntity();
                    obj.id_idioma = query.id_idioma;
                    obj.idioma = query.idioma;
                    return obj;
                }
                else
                {
                    return null;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error buscar idioma", MessageBoxButtons.OK, MessageBoxIcon.Error); return null;
            }
        }

        // ***********************************************************************************************
        // Afegir registre...
        public void afegirIdioma(idiomesEntity idiomaAct)
        {
            try
            {
                idiomes obj = new idiomes();
                obj.id_idioma = idiomaAct.id_idioma;
                obj.idioma = idiomaAct.idioma;

                dc.idiomes.InsertOnSubmit(obj);
                dc.SubmitChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error afegint idioma", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }


        // ***********************************************************************************************
        // Modificar registre...
        public void modificarIdioma(idiomesEntity idiomaAct)
        {
            var obj = (from d in dc.idiomes
                       where d.id_idioma == idiomaAct.id_idioma
                       select d).Single();

            try
            {
                obj.id_idioma = idiomaAct.id_idioma;
                obj.idioma = idiomaAct.idioma;
                dc.SubmitChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error modificant idioma", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }


        // ***********************************************************************************************
        // Eliminar registre...
        public void eliminarIdioma(string id_idioma)
        {
            try
            {
                var query = (from d in dc.idiomes
                             where d.id_idioma == id_idioma
                             select d).Single();
                dc.idiomes.DeleteOnSubmit(query);
                dc.SubmitChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error eliminant idioma", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }


        // ***********************************************************************************************
        //  Llistar els idiomes
        public List<idiomesEntity> llistarIdiomes()
        {
            try
            {
                List<idiomesEntity> llista = new List<idiomesEntity>();
                var query = (from d in dc.idiomes
                             where true
                             select d);
                foreach (var d in query)
                {
                    idiomesEntity obj = new idiomesEntity();
                    obj.id_idioma = d.id_idioma;
                    obj.idioma = d.idioma;
                    llista.Add(obj);
                }
                return llista;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error Llistar Idiomes", MessageBoxButtons.OK, MessageBoxIcon.Error); return null;
            }
        }

    }//fi classe
}//fi namespace
