﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.Windows.Forms;
using AccesDB;
using NegociEntitats;

namespace Negoci
{
    public class materiesCN
    {

        // Establim la connexió amb les classes que modelitzen la BD...
        DataClassesBibliotecaDataContext dc = new DataClassesBibliotecaDataContext();

        // ***********************************************************************************************
        //  Comprova si existeix una materia
        public Boolean existeixMateria(string id_materia)
        {
            try
            {
                var query = (from d in dc.materies
                             where d.id_materia.Equals(id_materia)
                             select d);

                if (query.Count() == 0) return false;
                return true;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error comprovant existencia materia", MessageBoxButtons.OK, MessageBoxIcon.Error); return false;
            }
        }

        // ***********************************************************************************************
        //  Buscar la materia
        public materiesEntity buscarMateria(string id_materia)
        {
            try
            {
                if (id_materia != null)
                {
                    //Buscar per Id, retorna descripcio
                    var query = (from d in dc.materies
                                 where d.id_materia.Equals(id_materia)
                                 select d).Single();
                    materiesEntity obj = new materiesEntity();
                    obj.id_materia = query.id_materia;
                    obj.materia = query.materia;
                    return obj;
                }
                else
                {
                    return null;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error Buscar Materies", MessageBoxButtons.OK, MessageBoxIcon.Error); return null;
            }
        }

        // ***********************************************************************************************
        // Afegir registre...
        public void afegirMateria(materiesEntity materiaAct)
        {
            try
            {

                materies obj = new materies();
                obj.id_materia = materiaAct.id_materia;
                obj.materia = materiaAct.materia;

                dc.materies.InsertOnSubmit(obj);
                dc.SubmitChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error afegint materia", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }


        // ***********************************************************************************************
        // Modificar registre...
        public void modificarMateria(materiesEntity materiaAct)
        {
            var obj = (from d in dc.materies
                       where d.id_materia == materiaAct.id_materia
                       select d).Single();

            try
            {
                obj.id_materia = materiaAct.id_materia;
                obj.materia = materiaAct.materia;
                dc.SubmitChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error modificant materia", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }


        // ***********************************************************************************************
        // Eliminar registre...
        public void eliminarMateria(string id_materia)
        {
            try
            {
                var query = (from d in dc.materies
                             where d.id_materia == id_materia
                             select d).Single();
                dc.materies.DeleteOnSubmit(query);
                dc.SubmitChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error eliminant materia", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        // ***********************************************************************************************
        //  Llistar les materies
        public List<materiesEntity> llistarMateries()
        {
            try
            {
                List<materiesEntity> llista = new List<materiesEntity>();
                var query = (from d in dc.materies
                             where true
                             select d);
                foreach (var d in query)
                {
                    materiesEntity obj = new materiesEntity();
                    obj.id_materia = d.id_materia;
                    obj.materia = d.materia;
                    llista.Add(obj);
                }
                return llista;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error List Materies", MessageBoxButtons.OK, MessageBoxIcon.Error); return null;
            }
        }



    }//fi classe
}//fi namespace