﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.Windows.Forms;
using AccesDB;
using NegociEntitats;

namespace Negoci
{
    public class temesCN
    {
        // Establim la connexió amb les classes que modelitzen la BD...
        DataClassesBibliotecaDataContext dc = new DataClassesBibliotecaDataContext();

        // ***********************************************************************************************
        //  Comprova si existeix un tema
        public Boolean existeixTema(string id_tema)
        {
            try
            {
                var query = (from d in dc.temes
                             where d.id_tema.Equals(id_tema)
                             select d);

                if (query.Count() == 0) return false;
                return true;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error comprovant existencia tema", MessageBoxButtons.OK, MessageBoxIcon.Error); return false;
            }
        }

        // ***********************************************************************************************
        //  Buscar el tema
        public temesEntity buscarTema(string id_tema)
        {
            try
            {
                if (id_tema != null)
                {
                    var query = (from d in dc.temes
                                 where d.id_tema.Equals(id_tema)
                                 select d).Single();
                    temesEntity obj = new temesEntity();
                    obj.id_tema = query.id_tema;
                    obj.tema = query.tema;
                    return obj;
                }
                else
                {
                    return null;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error Buscar Temes", MessageBoxButtons.OK, MessageBoxIcon.Error); return null;
            }
        }

        // ***********************************************************************************************
        // Afegir registre...
        public void afegirTema(temesEntity temaAct)
        {
            try
            {

                temes obj = new temes();
                obj.id_tema = temaAct.id_tema;
                obj.tema = temaAct.tema;

                dc.temes.InsertOnSubmit(obj);
                dc.SubmitChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error afegint tema", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }


        // ***********************************************************************************************
        // Modificar registre...
        public void modificarTema(temesEntity temaAct)
        {
            var obj = (from d in dc.temes
                       where d.id_tema == temaAct.id_tema
                       select d).Single();

            try
            {
                obj.id_tema = temaAct.id_tema;
                obj.tema = temaAct.tema;
                dc.SubmitChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error modificant tema", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }


        // ***********************************************************************************************
        // Eliminar registre...
        public void eliminarTema(string id_tema)
        {
            try
            {
                var query = (from d in dc.temes
                             where d.id_tema == id_tema
                             select d).Single();
                dc.temes.DeleteOnSubmit(query);
                dc.SubmitChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error eliminant tema", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }




        // ***********************************************************************************************
        //  Llistar els temes
        public List<temesEntity> llistarTemes()
        {
            try
            {
                List<temesEntity> llista = new List<temesEntity>();
                var query = (from d in dc.temes
                             where true
                             select d);
                foreach (var d in query)
                {
                    temesEntity obj = new temesEntity();
                    obj.id_tema = d.id_tema;
                    obj.tema = d.tema;
                    llista.Add(obj);
                }
                return llista;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error Llistar Temes", MessageBoxButtons.OK, MessageBoxIcon.Error); return null;
            }
        }




    }//fi classe
}//fi namespace