USE [biblioteca]
GO
/****** Object:  Table [dbo].[configuracio]    Script Date: 05/21/2013 21:50:19 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[configuracio](
	[id_config] [int] NOT NULL,
	[nomBiblioteca] [nvarchar](50) NOT NULL,
	[adrecaBiblioteca] [nvarchar](60) NULL,
	[cpBiblioteca] [nvarchar](5) NULL,
	[poblacioBiblioteca] [nvarchar](50) NULL,
	[telefonBiblioteca] [nvarchar](10) NULL,
	[emailBiblioteca] [nvarchar](50) NULL,
	[diesPrestec] [int] NOT NULL,
	[docsPrestec] [int] NOT NULL,
	[pswAdministrador] [nvarchar](15) NULL,
	[pswUsuari] [nvarchar](15) NULL,
 CONSTRAINT [PK_configuracio] PRIMARY KEY CLUSTERED 
(
	[id_config] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[usuaris]    Script Date: 05/21/2013 21:50:19 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[usuaris](
	[id_usuari] [int] IDENTITY(1,1) NOT NULL,
	[usuari] [nvarchar](25) NOT NULL,
	[contrasenya] [nvarchar](25) NULL,
	[rol] [int] NULL,
 CONSTRAINT [PK_usuaris] PRIMARY KEY CLUSTERED 
(
	[id_usuari] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[tipus_socis]    Script Date: 05/21/2013 21:50:19 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[tipus_socis](
	[id_tipusSoci] [int] NOT NULL,
	[tipusSoci] [nvarchar](50) NOT NULL,
 CONSTRAINT [PK_tipus_socis] PRIMARY KEY CLUSTERED 
(
	[id_tipusSoci] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[temes]    Script Date: 05/21/2013 21:50:19 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[temes](
	[id_tema] [nvarchar](10) NOT NULL,
	[tema] [nvarchar](50) NOT NULL,
 CONSTRAINT [PK_temes] PRIMARY KEY CLUSTERED 
(
	[id_tema] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[materies]    Script Date: 05/21/2013 21:50:19 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[materies](
	[id_materia] [nvarchar](10) NOT NULL,
	[materia] [nvarchar](50) NOT NULL,
 CONSTRAINT [PK_materies] PRIMARY KEY CLUSTERED 
(
	[id_materia] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[idiomes]    Script Date: 05/21/2013 21:50:19 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[idiomes](
	[id_idioma] [nvarchar](3) NOT NULL,
	[idioma] [nvarchar](20) NOT NULL,
 CONSTRAINT [PK_idiomes] PRIMARY KEY CLUSTERED 
(
	[id_idioma] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[formats]    Script Date: 05/21/2013 21:50:19 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[formats](
	[id_format] [nvarchar](10) NOT NULL,
	[format] [nvarchar](50) NOT NULL,
 CONSTRAINT [PK_formats] PRIMARY KEY CLUSTERED 
(
	[id_format] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[documents]    Script Date: 05/21/2013 21:50:19 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[documents](
	[id_document] [int] IDENTITY(1,1) NOT NULL,
	[titol] [nvarchar](80) NOT NULL,
	[subtitol] [nvarchar](80) NULL,
	[signatura] [nvarchar](15) NULL,
	[id_format] [nvarchar](10) NULL,
	[id_materia] [nvarchar](10) NULL,
	[id_tema] [nvarchar](10) NULL,
	[autor] [nvarchar](50) NULL,
	[autor2] [nvarchar](50) NULL,
	[autor3] [nvarchar](50) NULL,
	[publicacioEditorial] [nvarchar](50) NULL,
	[publicacioLloc] [nvarchar](50) NULL,
	[publicacioAny] [int] NULL,
	[publicacioEdicio] [nvarchar](50) NULL,
	[coleccioNom] [nvarchar](50) NULL,
	[isbn] [nvarchar](20) NULL,
	[dipositLegal] [nvarchar](50) NULL,
	[idioma] [nvarchar](3) NULL,
	[director] [nvarchar](50) NULL,
	[interprets] [nvarchar](100) NULL,
	[calificacio] [nvarchar](25) NULL,
	[sinopsis] [nvarchar](250) NULL,
	[numPagines] [int] NULL,
	[duradaMinuts] [int] NULL,
	[color] [nvarchar](1) NULL,
	[dataAlta] [date] NULL,
	[numUnitats] [int] NULL,
	[numUnitatsDisponibles] [int] NULL,
	[imatge] [nvarchar](80) NULL,
	[actiu] [bit] NOT NULL,
 CONSTRAINT [PK_documents] PRIMARY KEY CLUSTERED 
(
	[id_document] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[socis]    Script Date: 05/21/2013 21:50:19 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[socis](
	[id_soci] [int] IDENTITY(1,1) NOT NULL,
	[nom] [nvarchar](50) NOT NULL,
	[cognoms] [nvarchar](50) NULL,
	[sexe] [nvarchar](1) NULL,
	[dni] [nvarchar](10) NULL,
	[dataNaixement] [date] NULL,
	[id_tipusSoci] [int] NULL,
	[adreca] [nvarchar](80) NULL,
	[cp] [nvarchar](5) NULL,
	[poblacio] [nvarchar](50) NULL,
	[provincia] [nvarchar](50) NULL,
	[pais] [nvarchar](50) NULL,
	[telefon] [nvarchar](10) NULL,
	[email] [nvarchar](50) NULL,
	[dataAlta] [date] NULL,
	[dataBaixa] [date] NULL,
	[esBaixa] [bit] NOT NULL,
	[contrasenya] [nvarchar](50) NULL,
	[actiu] [bit] NOT NULL,
 CONSTRAINT [PK_socis] PRIMARY KEY CLUSTERED 
(
	[id_soci] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[prestecs]    Script Date: 05/21/2013 21:50:19 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[prestecs](
	[id_prestec] [int] IDENTITY(1,1) NOT NULL,
	[id_document] [int] NOT NULL,
	[id_soci] [int] NOT NULL,
	[dataIniciPrestec] [date] NOT NULL,
	[dataFiPrestec] [date] NULL,
	[dataRetornPrestec] [date] NULL,
	[numRenovacions] [int] NULL,
	[retornat] [bit] NOT NULL,
 CONSTRAINT [PK_prestecs] PRIMARY KEY CLUSTERED 
(
	[id_prestec] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  ForeignKey [FK_documents_formats]    Script Date: 05/21/2013 21:50:19 ******/
ALTER TABLE [dbo].[documents]  WITH CHECK ADD  CONSTRAINT [FK_documents_formats] FOREIGN KEY([id_format])
REFERENCES [dbo].[formats] ([id_format])
GO
ALTER TABLE [dbo].[documents] CHECK CONSTRAINT [FK_documents_formats]
GO
/****** Object:  ForeignKey [FK_documents_idiomes]    Script Date: 05/21/2013 21:50:19 ******/
ALTER TABLE [dbo].[documents]  WITH CHECK ADD  CONSTRAINT [FK_documents_idiomes] FOREIGN KEY([idioma])
REFERENCES [dbo].[idiomes] ([id_idioma])
GO
ALTER TABLE [dbo].[documents] CHECK CONSTRAINT [FK_documents_idiomes]
GO
/****** Object:  ForeignKey [FK_documents_materies]    Script Date: 05/21/2013 21:50:19 ******/
ALTER TABLE [dbo].[documents]  WITH CHECK ADD  CONSTRAINT [FK_documents_materies] FOREIGN KEY([id_materia])
REFERENCES [dbo].[materies] ([id_materia])
GO
ALTER TABLE [dbo].[documents] CHECK CONSTRAINT [FK_documents_materies]
GO
/****** Object:  ForeignKey [FK_documents_temes]    Script Date: 05/21/2013 21:50:19 ******/
ALTER TABLE [dbo].[documents]  WITH CHECK ADD  CONSTRAINT [FK_documents_temes] FOREIGN KEY([id_tema])
REFERENCES [dbo].[temes] ([id_tema])
GO
ALTER TABLE [dbo].[documents] CHECK CONSTRAINT [FK_documents_temes]
GO
/****** Object:  ForeignKey [FK_prestecs_documents]    Script Date: 05/21/2013 21:50:19 ******/
ALTER TABLE [dbo].[prestecs]  WITH CHECK ADD  CONSTRAINT [FK_prestecs_documents] FOREIGN KEY([id_document])
REFERENCES [dbo].[documents] ([id_document])
GO
ALTER TABLE [dbo].[prestecs] CHECK CONSTRAINT [FK_prestecs_documents]
GO
/****** Object:  ForeignKey [FK_prestecs_socis]    Script Date: 05/21/2013 21:50:19 ******/
ALTER TABLE [dbo].[prestecs]  WITH CHECK ADD  CONSTRAINT [FK_prestecs_socis] FOREIGN KEY([id_soci])
REFERENCES [dbo].[socis] ([id_soci])
GO
ALTER TABLE [dbo].[prestecs] CHECK CONSTRAINT [FK_prestecs_socis]
GO
/****** Object:  ForeignKey [FK_socis_tipus_socis]    Script Date: 05/21/2013 21:50:19 ******/
ALTER TABLE [dbo].[socis]  WITH CHECK ADD  CONSTRAINT [FK_socis_tipus_socis] FOREIGN KEY([id_tipusSoci])
REFERENCES [dbo].[tipus_socis] ([id_tipusSoci])
GO
ALTER TABLE [dbo].[socis] CHECK CONSTRAINT [FK_socis_tipus_socis]
GO
