﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Terminal
{
    public partial class frm0Menu : Form
    {
        private string usuariLogin = "";
        private int usuariRol = 0;
        private gblParametres parametres = gblParametres.Instance();
        
        public frm0Menu()
        {
            InitializeComponent();
        }

        //*********************************************************************************
        //Carga del formulari...
        private void frm0Menu_Load(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Maximized;

            lblUsuariLogin.Visible = false;
            loginInicial();
            if (usuariRol==0) this.Dispose();

            //inicializar gblParametres
            inicialitzarGblparametres();

        }


        //*********************************************************************************
        //Procés login inicial...
        private void loginInicial()
        {
            frm1Connexio f = new frm1Connexio();
            f.WindowState = FormWindowState.Normal;
            f.ShowDialog();

            //Login inicial no realitzat, es surt de l'aplicació...
            if (f.usuariRol == 0)
            {
                DialogResult result = MessageBox.Show("Usuari no validat" + System.Environment.NewLine + System.Environment.NewLine + "Aplicació finalitzada", "UOCBiblioteca", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            this.usuariLogin = f.usuariLogin;
            this.usuariRol = f.usuariRol;
            f.Close();
            lblUsuariLogin.Text = "Usuari connectat:  " + this.usuariLogin;
            lblUsuariLogin.Visible = true;
            activarOpcions();
        }


        //*********************************************************************************
        private void connexióToolStripMenuItem_Click(object sender, EventArgs e)
        {
            lblUsuariLogin.Visible = false;

            frm1Connexio f = new frm1Connexio();
            f.WindowState = FormWindowState.Normal;
            f.ShowDialog();

            //Comprova si el canvi d'usuari ha estat correcte...
            if (f.usuariRol != 0)
            {
                this.usuariLogin = f.usuariLogin;
                this.usuariRol = f.usuariRol;
                lblUsuariLogin.Text = "Usuari connectat:  " + this.usuariLogin;
                activarOpcions();
            }
            f.Close();

            lblUsuariLogin.Visible = true;

        }


        //*********************************************************************************
        private void documentsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (windowActiva("frm2DocumentVer")) return;

            frm2DocumentVer f = new frm2DocumentVer();
            f.WindowState = FormWindowState.Maximized;
            f.MdiParent = this;
            f.Show();
        }

        //*********************************************************************************
        private void socisToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (windowActiva("frm3SociVer")) return;

            frm3SociVer f = new frm3SociVer();
            f.WindowState = FormWindowState.Maximized;
            f.MdiParent = this;
            f.Show();
        }

        //*********************************************************************************
        private void préstecToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (windowActiva("frm4Prestec")) return;

            frm4Prestec f = new frm4Prestec(1);
            f.WindowState = FormWindowState.Maximized;
            f.MdiParent = this;
            f.Show();
        }

        //*********************************************************************************
        private void devolucióToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (windowActiva("frm4Prestec")) return;

            frm4Prestec f = new frm4Prestec(2);
            f.WindowState = FormWindowState.Maximized;
            f.MdiParent = this;
            f.Show();
        }

        //*********************************************************************************
        private void renovacióToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (windowActiva("frm4Prestec")) return;

            frm4Prestec f = new frm4Prestec(3);
            f.WindowState = FormWindowState.Maximized;
            f.MdiParent = this;
            f.Show();
        }

        //*********************************************************************************
        private void consultaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (windowActiva("frm4PrestecVer")) return;

            frm4PrestecVer f = new frm4PrestecVer();
            f.WindowState = FormWindowState.Maximized;
            f.MdiParent = this;
            f.Show();

        }

        //*********************************************************************************
        private void configuracióToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (windowActiva("frm5Configuracio")) return;

            frm5Configuracio f = new frm5Configuracio();
            f.WindowState = FormWindowState.Maximized;
            f.MdiParent = this;
            f.Show();
        }

        //*********************************************************************************
        private void temesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (windowActiva("frm5TemaVer")) return;

            frm5TemaVer f = new frm5TemaVer();
            f.WindowState = FormWindowState.Maximized;
            f.MdiParent = this;
            f.Show();

        }
        
        //*********************************************************************************
        private void materiesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (windowActiva("frm5MateriaVer")) return;

            frm5MateriaVer f = new frm5MateriaVer();
            f.WindowState = FormWindowState.Maximized;
            f.MdiParent = this;
            f.Show();

        }

        //*********************************************************************************
        private void formatsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (windowActiva("frm5FormatVer")) return;

            frm5FormatVer f = new frm5FormatVer();
            f.WindowState = FormWindowState.Maximized;
            f.MdiParent = this;
            f.Show();

        }

        //*********************************************************************************
        private void idiomesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (windowActiva("frm5IdiomaVer")) return;

            frm5IdiomaVer f = new frm5IdiomaVer();
            f.WindowState = FormWindowState.Maximized;
            f.MdiParent = this;
            f.Show();

        }

        //*********************************************************************************
        private void tipusSociToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (windowActiva("frm5TipusSociVer")) return;

            frm5TipusSociVer f = new frm5TipusSociVer();
            f.WindowState = FormWindowState.Maximized;
            f.MdiParent = this;
            f.Show();

        }

        
        //*********************************************************************************
        private void ajudaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (windowActiva("frm9Ajuda")) return;

            frm9Ajuda f = new frm9Ajuda();
            f.WindowState = FormWindowState.Normal;
            f.ShowDialog();
            f.Close();

            //frm9Proves f2 = new frm9Proves();
            //f2.WindowState = FormWindowState.Normal;
            //f2.MdiParent = this;
            //f2.Show();


        }


        //*********************************************************************************
        private void sortirToolStripMenuItem_Click(object sender, EventArgs e)
        {
            DialogResult result = MessageBox.Show("Desitja sortir de l'aplicació ?", "Sortir", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
            if (result == DialogResult.Yes)
            {
                this.Dispose();
            }
        }

        //*********************************************************************************
        private void frm0Menu_FormClosing(object sender, FormClosingEventArgs e)
        {
            DialogResult result = MessageBox.Show("Desitja sortir de l'aplicació ?", "Sortir", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
            //Cancel.lar el formclossing...
            if (result == DialogResult.No)
            {
                e.Cancel = true;
            }
        }

        //*********************************************************************************
        //   Inicialitzar gblParametres
        private void inicialitzarGblparametres()
        {
            parametres.frm2DocumentVer = 0;
            parametres.frm3SociVer = 0;
            parametres.frm4Prestec = 0;
            parametres.frm4PrestecVer = 0;
            parametres.frm5MateriaVer = 0;
            parametres.frm5TemaVer = 0;
            parametres.frm5FormatVer = 0;
            parametres.frm5IdiomaVer = 0;
            parametres.frm5TipusSociVer = 0;
            parametres.frm9Ajuda = 0;

        }

        //*********************************************************************************
        //   Activa opcions de menu segon el usuari actiu
        private void activarOpcions()
        {
            //Rol administrador...
            if (usuariRol == 1)
            {
                configuracióToolStripMenuItem.Enabled = true;
                materiesToolStripMenuItem.Enabled = true;
                temesToolStripMenuItem.Enabled = true;
                formatsToolStripMenuItem.Enabled = true;
                idiomesToolStripMenuItem.Enabled = true;
                tipusSociToolStripMenuItem.Enabled = true;

            }

            //Rol usuari normal...
            if (usuariRol == 2)
            {
                configuracióToolStripMenuItem.Enabled = false;
                materiesToolStripMenuItem.Enabled = false;
                temesToolStripMenuItem.Enabled = false;
                formatsToolStripMenuItem.Enabled = false;
                idiomesToolStripMenuItem.Enabled = false;
                tipusSociToolStripMenuItem.Enabled = false;
            }

            //Pasar usuari a gblParametres...
            parametres.usuariLogin = this.usuariLogin;
            parametres.usuariRol = this.usuariRol;

        }


        //*********************************************************************************
        //   Comprova si ja hi ha una instància activa de la window
        private Boolean windowActiva(string windowAct)
        {
            Boolean swactiva = false;

            switch (windowAct)
            {
                case "frm2DocumentVer":
                    if (parametres.frm2DocumentVer == 1) swactiva = true;
                    parametres.frm2DocumentVer = 1;
                    break;

                case "frm3SociVer":
                    if (parametres.frm3SociVer == 1) swactiva = true;
                    parametres.frm3SociVer = 1;
                    break;

                case "frm4Prestec":
                    if (parametres.frm4Prestec == 1) swactiva = true;
                    parametres.frm4Prestec = 1;
                    break;

                case "frm4PrestecVer":
                    if (parametres.frm4PrestecVer == 1) swactiva = true;
                    parametres.frm4PrestecVer = 1;
                    break;

                case "frm5Configuracio":
                    if (parametres.frm5Configuracio == 1) swactiva = true;
                    parametres.frm5Configuracio = 1;
                    break;

                case "frm5MateriaVer":
                    if (parametres.frm5MateriaVer == 1) swactiva = true;
                    parametres.frm5MateriaVer = 1;
                    break;

                case "frm5TemaVer":
                    if (parametres.frm5TemaVer == 1) swactiva = true;
                    parametres.frm5TemaVer = 1;
                    break;

                case "frm5FormatVer":
                    if (parametres.frm5FormatVer == 1) swactiva = true;
                    parametres.frm5FormatVer = 1;
                    break;

                case "frm5IdiomaVer":
                    if (parametres.frm5IdiomaVer == 1) swactiva = true;
                    parametres.frm5IdiomaVer = 1;
                    break;

                case "frm5TipusSociVer":
                    if (parametres.frm5TipusSociVer == 1) swactiva = true;
                    parametres.frm5TipusSociVer = 1;
                    break;

                case "frm9Ajuda":
                    if (parametres.frm9Ajuda == 1) swactiva = true;
                    parametres.frm9Ajuda = 1;
                    break;

                default:
                    break;
            }

            //Avis window ja activa...
            if (swactiva)
            {
                DialogResult result = MessageBox.Show("Opció ja activa", "UOCBiblioteca", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }


            return swactiva;

        }



    }//fi classe
}//fi namespace
