﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Negoci;
using Terminal.ServiceReference1;
using NegociEntitats;


namespace Terminal
{
    public partial class frm1Connexio : Form
    {

        private ServiceReference1.Service1Client clientWCF = new ServiceReference1.Service1Client(); // Instancia del servei WCF
        //private simulawcfCN clientWCF = new simulawcfCN(); // simula WCF
        
        private configuracioEntity configuracioAct = new configuracioEntity();
        public string usuariLogin = "";
        public int usuariRol = 0;   // rol=0 - error login
        
        
        public frm1Connexio()
        {
            InitializeComponent();
        }

        private void frm1Connexio_Load(object sender, EventArgs e)
        {
            cmbUsuari.SelectedIndex = 1;
            chkVeureContrasenyes.Checked = false;
        }

        //*****************************************************************************
        private void acceptarButton_Click(object sender, EventArgs e)
        {
            string usuariRetorn = "";
            usuariRetorn = clientWCF.validarLoginConfiguracio(cmbUsuari.Text, txtContrasenya.Text);

            if (usuariRetorn == "Error")
            {
                DialogResult result = MessageBox.Show("Usuari no validat", "Connexió", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtContrasenya.Text = "";
                cmbUsuari.Focus();
                return;
            }

            //Usuari correcte
            //  usuariRol = 0 - error login
            //            = 1 - rol administrador
            //            = 2 - rol usuari normal
            this.usuariLogin = cmbUsuari.Text;
            this.usuariRol = 2;  
            if (cmbUsuari.SelectedIndex==0) this.usuariRol = 1;
            this.Close();

        }

        //*********************************************************************************************************+
        private void cancelarButton_Click(object sender, EventArgs e)
        {
            this.Dispose();
        }

        //*********************************************************************************************************+
        //Buscar a la BD...
        private void buscarConfiguracio()
        {
            configuracioAct = clientWCF.buscarConfiguracio();
        }

        //*********************************************************************************************************+
        // ensenyar/amagar les contrasenyes
        private void chkVeureContrasenyes_CheckedChanged(object sender, EventArgs e)
        {
            if (chkVeureContrasenyes.Checked == true)
            {
                txtContrasenya.PasswordChar = char.Parse("\0");

            }
            else
            {
                txtContrasenya.PasswordChar = char.Parse("*");
            }
        }


    }//fi classe
}//fi namespace
