﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Negoci;
using Terminal.ServiceReference1;
using NegociEntitats;


namespace Terminal
{
    public partial class frm2DocumentVer : Form
    {
        private ServiceReference1.Service1Client clientWCF = new ServiceReference1.Service1Client(); // Instancia del servei WCF
        //private simulawcfCN clientWCF = new simulawcfCN(); // simula WCF

        private List<documentsEntity> ListDocs;
        private string w_opcioCercar = "";


        public frm2DocumentVer()
        {
            InitializeComponent();

        }

        private void btnSortir_Click(object sender, EventArgs e)
        {
            gblParametres parametres = gblParametres.Instance();
            parametres.frm2DocumentVer = 0;
            this.Dispose();
        }

        //Cargar formulari...
        private void frm2DocumentVer_Load(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Maximized;
            txtCercar.Text = "";
            cmbCercar.SelectedIndex = 0;

            //Desactivar opcions segons usuari actiu
            //  si rol=2 (usuari normal), desactivar opcions
            gblParametres parametres = gblParametres.Instance();
            if (parametres.usuariRol== 2)
            {
                btnNouDocument.Enabled = false;
            }
        }


        //****************************************************************************************
        private void btnModificar_Click(object sender, EventArgs e)
        {
            //Comprovem si hi ha quelcom a la llista...
            if (gridDocuments.RowCount == 0)
            {
                return; 
            }
            //recuperem la linea sel.lecionada

            DataGridViewRow row = this.gridDocuments.CurrentRow;
            int id_document = 0;
            id_document = Convert.ToInt32(row.Cells[0].Value);
            //modificar ....
            frm2Document f = new frm2Document(id_document);
            f.WindowState = FormWindowState.Normal;
            f.ShowDialog();

            //Refresca el grid, per si hi han canvis...
            cercarDadesGrid();

        }

        //****************************************************************************************
        private void btnVeureTots_Click(object sender, EventArgs e)
        {
            txtId_document.Text  = "";
            txtCercar.Text  = "";
            cmbCercar.SelectedIndex = 0;
            w_opcioCercar = "veuretots";
            cercarDadesGrid();
        }

        //****************************************************************************************
        private void btnCercar_Click(object sender, EventArgs e)
        {
            Boolean correcte = true;
            correcte = validarCamps();

            if (!correcte)
            {
                return;
            }

            w_opcioCercar = "cercar";
            cercarDadesGrid();

        }

        //****************************************************************************************
        private void btnNouDocument_Click(object sender, EventArgs e)
        {
            //Nou document ....
            frm2Document f = new frm2Document(0);
            f.WindowState = FormWindowState.Normal;
            f.ShowDialog();

            //Situar-se...
            txtId_document.Focus();
        }


        //****************************************************************************************
        //Validar els camps introduits...
        private Boolean validarCamps()
        {

            Boolean correcte = true;
            int number = 0;
            //Valida l'entrada id_document que sigui numeric...
            txtId_document.Text = txtId_document.Text.Trim();
            if (String.IsNullOrEmpty(txtId_document.Text) == false)
            {
               if (int.TryParse(txtId_document.Text.Trim(), out number) == false)
               {
                   DialogResult result = MessageBox.Show("Introduir sols números", "Id document", MessageBoxButtons.OK, MessageBoxIcon.Error);
                   correcte = false;
               }
            }

            //No s'ha introduit res per cercar...
            if (String.IsNullOrEmpty(txtId_document.Text) == true && String.IsNullOrEmpty(txtCercar.Text))
            {
                correcte = false;
            }

            
            return correcte;
        }

        //****************************************************************************************
        // Buscar dades per ficar al Datagrid...
        private void cercarDadesGrid()
        {
            //documentCN obj = new documentCN();
            
            //Esborrar grid...
            gridDocuments.DataSource = null;
            gridDocuments.Rows.Clear();
            gridDocuments.ClearSelection();

            //Botó VeureTots...
            if (w_opcioCercar == "veuretots")
            {
                ListDocs = clientWCF.llistarDocuments(1, "").ToList();
            }

            //Botó Cercar...
            if (w_opcioCercar == "cercar")
            {
                int numId = 0;
                if (String.IsNullOrEmpty(txtId_document.Text) == false)
                {
                    numId = Convert.ToInt32(txtId_document.Text);
                }

                //Cercar per id_document
                if (numId != 0)
                {
                    ListDocs = clientWCF.llistarDocuments(2, Convert.ToString(txtId_document.Text)).ToList();
                }
                else
                {
                    //Cercar per titol, autor, tema, isbn, signatura
                    if (String.IsNullOrEmpty(txtCercar.Text) == false)
                    {
                        //El index del combo+3 indica el tipo de busqueda per la llista de llistDocuments
                        // 3=titol, 4=autor, 5=tema, 6=isbn, 7=signatura
                        int selectedIndex = cmbCercar.SelectedIndex;
                        selectedIndex += 3;
                        ListDocs = clientWCF.llistarDocuments(selectedIndex, txtCercar.Text).ToList();
                    }
                }
            }

            //carregar el grid...
            carregarGrid();

        }


        //****************************************************************************************
        // Carrega la llista al datagridView .....
        private void carregarGrid()
        {
            Boolean llistaBuida = false;
            if (ListDocs == null) llistaBuida = true;
            if (!llistaBuida)
            {
                if (ListDocs.Count == 0) llistaBuida = true;
            }
            if (llistaBuida)
            {
                DialogResult nada = MessageBox.Show("No hi han documents que compleixin les condicions de cerca", "Consulta préstecs", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return;
            }

            //Passar la llista de documents obtinguda al grid...
            for (int i = 0; i < ListDocs.Count(); i++)
            {
            //    MessageBox.Show(ListDocs.ElementAt(i).id_document + "-" + ListDocs.ElementAt(i).signatura + "-" + ListDocs.ElementAt(i).titol + "-" + ListDocs.ElementAt(i).autor + "-" + ListDocs.ElementAt(i).publicacioAny);
                
                gridDocuments.Rows.Add();
                gridDocuments.Rows[i].Cells[0].Value = ListDocs.ElementAt(i).id_document;
                gridDocuments.Rows[i].Cells[1].Value = ListDocs.ElementAt(i).signatura;
                gridDocuments.Rows[i].Cells[2].Value = ListDocs.ElementAt(i).titol;
                gridDocuments.Rows[i].Cells[3].Value = ListDocs.ElementAt(i).autor;
                gridDocuments.Rows[i].Cells[4].Value = ListDocs.ElementAt(i).publicacioAny;
                gridDocuments.Rows[i].Cells[5].Value = ListDocs.ElementAt(i).id_format;
            }

            gridDocuments.Refresh();

        }

        //****************************************************************************************
        private void gridDocuments_DoubleClick(object sender, EventArgs e)
        {
            btnModificar_Click(sender, e);
        }

        //****************************************************************************************
        private void frm2DocumentVer_FormClosing(object sender, FormClosingEventArgs e)
        {
            gblParametres parametres = gblParametres.Instance();
            parametres.frm2DocumentVer = 0;
        }




    } //fi classe
} //fi namepace
