﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Negoci;
using Terminal.ServiceReference1;
using NegociEntitats;


namespace Terminal
{
    public partial class frm3SociVer : Form
    {
        private ServiceReference1.Service1Client clientWCF = new ServiceReference1.Service1Client(); // Instancia del servei WCF
        //private simulawcfCN clientWCF = new simulawcfCN(); // simula WCF
        
        private List<socisEntity> ListSocis; 
        private string w_opcioCercar = "";

        public frm3SociVer()
        {
            InitializeComponent();

        }

        private void btnSortir_Click(object sender, EventArgs e)
        {
            gblParametres parametres = gblParametres.Instance();
            parametres.frm3SociVer = 0;
            this.Dispose();
        }

        //****************************************************************************************
        //Cargar formulari...
        private void frm3SociVer_Load(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Maximized;
            txtCercar.Text = "";
            cmbCercar.SelectedIndex = 0;


            //Desactivar opcions segons usuari actiu
            //  si rol=2 (usuari normal), desactivar opcions
            gblParametres parametres = gblParametres.Instance();
            if (parametres.usuariRol == 2)
            {
                btnNouSoci.Enabled = false;
            }
        }


        //****************************************************************************************
        private void btnModificar_Click(object sender, EventArgs e)
        {
            //Comprovem si hi ha quelcom a la llista...
            if (gridSocis.RowCount == 0)
            {
                return; 
            }
            //recuperem la linea sel.lecionada
            DataGridViewRow row = this.gridSocis.CurrentRow;
            int id_soci = 0;
            id_soci = Convert.ToInt32(row.Cells[0].Value);
            //modificar ....
            frm3Soci f = new frm3Soci(id_soci);
            f.WindowState = FormWindowState.Normal;
            f.ShowDialog();

            //Refresca el grid, per si hi han canvis...
            cercarDadesGrid();

        }

        //****************************************************************************************
        private void btnVeureTots_Click(object sender, EventArgs e)
        {
            txtId_soci.Text  = "";
            txtCercar.Text  = "";
            cmbCercar.SelectedIndex = 0;
            w_opcioCercar = "veuretots";
            cercarDadesGrid();
        }

        private void btnCercar_Click(object sender, EventArgs e)
        {
            Boolean correcte = true;
            correcte = validarCamps();

            if (!correcte)
            {
                return;
            }

            w_opcioCercar = "cercar";
            cercarDadesGrid();

        }

        //****************************************************************************************
        private void btnNouSoci_Click(object sender, EventArgs e)
        {
            //Nou document ....
            frm3Soci f = new frm3Soci(0);
            f.WindowState = FormWindowState.Normal;
            f.ShowDialog();

            //Situar-se...
            txtId_soci.Focus();
        }


        //****************************************************************************************
        //Validar els camps introduits...
        private Boolean validarCamps()
        {

            Boolean correcte = true;
            int number = 0;
            //Valida l'entrada id_soci que sigui numeric...
            txtId_soci.Text = txtId_soci.Text.Trim();
            if (String.IsNullOrEmpty(txtId_soci.Text) == false)
            {
               if (int.TryParse(txtId_soci.Text.Trim(), out number) == false)
               {
                   DialogResult result = MessageBox.Show("Introduir sols números", "Id soci", MessageBoxButtons.OK, MessageBoxIcon.Error);
                   correcte = false;
               }
            }

            //No s'ha introduit res per cercar...
            if (String.IsNullOrEmpty(txtId_soci.Text) == true && String.IsNullOrEmpty(txtCercar.Text))
            {
                correcte = false;
            }

            
            return correcte;
        }

        //****************************************************************************************
        // Buscar dades per ficar al Datagrid...
        private void cercarDadesGrid()
        {
            //documentCN obj = new documentCN();
            
            //Esborrar grid...
            gridSocis.DataSource = null;
            gridSocis.Rows.Clear();
            gridSocis.ClearSelection();

            //Botó VeureTots...
            if (w_opcioCercar == "veuretots")
            {
                ListSocis = clientWCF.llistarSocis(1, "").ToList();
            }

            //Botó Cercar...
            if (w_opcioCercar == "cercar")
            {
                int numId = 0;
                if (String.IsNullOrEmpty(txtId_soci.Text) == false)
                {
                    numId = Convert.ToInt32(txtId_soci.Text);
                }

                //Cercar per id_soci
                if (numId != 0)
                {
                    ListSocis = clientWCF.llistarSocis(2, Convert.ToString(txtId_soci.Text)).ToList();
                }
                else
                {
                    //Cercar per cognoms,dni
                    if (String.IsNullOrEmpty(txtCercar.Text) == false)
                    {
                        //El index del combo+3 indica el tipo de busqueda per la llista de llistarSocis
                        // 3=nom, 4=dni
                        int selectedIndex = cmbCercar.SelectedIndex;
                        selectedIndex += 3;
                        ListSocis = clientWCF.llistarSocis(selectedIndex, txtCercar.Text).ToList(); 
                    }
                }
            }

            //carregar el grid...
            carregarGrid();

        }


        //****************************************************************************************
        // Carrega la llista al datagridView .....
        private void carregarGrid()
        {
            Boolean llistaBuida = false;
            if (ListSocis == null) llistaBuida = true;
            if (!llistaBuida)
            {
                if (ListSocis.Count == 0) llistaBuida = true;
            }
            if (llistaBuida)
            {
                DialogResult nada = MessageBox.Show("No hi han socis que compleixin les condicions de cerca", "Consulta préstecs", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return;
            }

            //Passar la llista de documents obtinguda al grid...
            for (int i = 0; i < ListSocis.Count(); i++)
            {
                gridSocis.Rows.Add();
                gridSocis.Rows[i].Cells[0].Value = ListSocis.ElementAt(i).id_soci;
                gridSocis.Rows[i].Cells[1].Value = ListSocis.ElementAt(i).cognoms;
                gridSocis.Rows[i].Cells[2].Value = ListSocis.ElementAt(i).nom;
                gridSocis.Rows[i].Cells[3].Value = ListSocis.ElementAt(i).dni;
            }

            gridSocis.Refresh();

        }


        //****************************************************************************************
        private void gridDocuments_DoubleClick(object sender, EventArgs e)
        {
            btnModificar_Click(sender, e);
        }

        //****************************************************************************************
        private void frm3SociVer_FormClosing(object sender, FormClosingEventArgs e)
        {
            gblParametres parametres = gblParametres.Instance();
            parametres.frm3SociVer = 0;
        }



    } //fi classe
} //fi namepace
