﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Globalization;
using Negoci;
using Terminal.ServiceReference1;
using NegociEntitats;


namespace Terminal
{
    public partial class frm4Prestec : Form
    {
        private ServiceReference1.Service1Client clientWCF = new ServiceReference1.Service1Client(); // Instancia del servei WCF
        //private simulawcfCN clientWCF = new simulawcfCN(); // simula WCF

        private documentsEntity documentAct = new documentsEntity();
        private socisEntity sociAct = new socisEntity();
        private prestecsEntity prestecAct = new prestecsEntity();
        private configuracioEntity configuracioAct = new configuracioEntity();
        private int opcioAct = 0;
        private int id_prestecAct = 0;
        private int id_documentAct = 0;
        private int id_sociAct = 0;
        private DateTime w_dataIniciPrestec;
        Boolean swsalir = false;


        //***********************************************************************************************************
        //   opcio 1 = Préstec
        //         2 = Devolució
        //         3 = Renovació
        public frm4Prestec(int opcio)
        {
            InitializeComponent();
            opcioAct = opcio;
        }

        private void frm4Prestec_Load(object sender, EventArgs e)
        {

            buscarConfiguracio();
            txtId_document1.Focus();
            
            // prestec
            if (opcioAct == 1)
            {
                nouPrestec();
                //activar el tabcontrol 
                tabControl1.SelectedIndex = 0;
            }

            // Devolució
            if (opcioAct == 2)
            {
                nouDevolucio();
                //activar el tabcontrol 
                tabControl1.SelectedIndex = 1;
            }

            // Renovació
            if (opcioAct == 3)
            {
                nouRenovacio();
                //activar el tabcontrol 
                tabControl1.SelectedIndex = 2;
            }

        }

        
        //***********************************************************************************************************
        // PRESTEC
        private void txtId_document_Leave(object sender, EventArgs e)
        {
            if (swsalir) return;
            if (txtId_document1.Text == "")
            {
                nouPrestec(); 
                return;
            }
            if (validarNumero(txtId_document1.Text) == false) 
            {
                DialogResult result = MessageBox.Show("ID DOCUMENT sols admet números", "Préstec", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtId_document1.Focus();
                return;
            }
            id_documentAct = Convert.ToInt32(txtId_document1.Text);
            if (clientWCF.existeixDocument(id_documentAct) == false)
            {
                txtTitol1.Text = "";
                txtFormat1.Text = "";
                DialogResult result = MessageBox.Show("Document inexistent", "Préstec", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtId_document1.Focus();
                return;
            }

            //Buscar el document i comprovar si està disponible......
            buscarDocument();

            if (disponibleDocument() == false)
            {
                DialogResult result = MessageBox.Show("El document no està disponible per préstec", "Préstec", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtId_document1.Text = "";
                txtTitol1.Text = "";
                txtFormat1.Text = "";
                txtId_document1.Focus();
                return;
            }

            //Correcte, activo el id_soci
            txtId_soci1.ReadOnly = false;
            btnSociHelp1.Enabled = true;

        }

        //***********************************************************************************************************
        // PRESTEC
        private void txtId_soci_Leave(object sender, EventArgs e)
        {
            int numero = 0;

            if (swsalir) return;
            if (txtId_soci1.Text == "") return;

            if (validarNumero(txtId_soci1.Text) == false)
            {
                DialogResult result = MessageBox.Show("ID SOCI sols admet números", "Préstec", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtId_soci1.Focus();
                return;
            }
            id_sociAct = Convert.ToInt32(txtId_soci1.Text);
            if (clientWCF.existeixSoci(id_sociAct) == false)
            {
                txtNom1.Text = "";
                DialogResult result = MessageBox.Show("Soci inexistent", "Préstec", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtId_soci1.Focus();
                return;
            }

            //Buscar el document i comprovar si està disponible......
            buscarSoci();

            if (disponibleSoci() == false)
            { 
                DialogResult result = MessageBox.Show("El soci no pot realitzar préstecs", "Préstec", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtId_soci1.Text = "";
                txtNom1.Text = "";
                txtId_soci1.Focus();
                return;
            }

            numero = clientWCF.buscarPrestecsActiusIdSoci(id_sociAct);
            if (numero >= configuracioAct.docsPrestec)
            {
                DialogResult result = MessageBox.Show("El soci ja te " + numero.ToString() + " préstecs actius. " + System.Environment.NewLine + System.Environment.NewLine +
                                                      "No pot realitzar més préstecs.", "Préstec", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                txtId_soci1.Text = "";
                txtNom1.Text = "";
                txtId_soci1.Focus();
                return;
            }



            //Correcte... calculo data fi prestec i activo controls...
            calcularDataFiPrestec();
            txtDataIniciPrestec1.ReadOnly = false;
            txtDataFiPrestec1.ReadOnly = false;
            acceptarButton1.Enabled = true;
            acceptarButton1.Focus();

        }


        //***********************************************************************************************************
        // DEVOLUCIO
        private void txtId_document2_Leave(object sender, EventArgs e)
        {
            if (swsalir) return;
            if (txtId_document2.Text == "")
            {
                nouDevolucio();
                return;
            }

            if (validarNumero(txtId_document2.Text) == false)
            {
                DialogResult result = MessageBox.Show("ID DOCUMENT sols admet números", "Devolució", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtId_document2.Focus();
                return;
            }
            id_documentAct = Convert.ToInt32(txtId_document2.Text);
            if (clientWCF.existeixDocument(id_documentAct) == false)
            {
                txtTitol2.Text = "";
                txtFormat2.Text = "";
                DialogResult result = MessageBox.Show("Document inexistent", "Devolució", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtId_document2.Focus();
                return;
            }

            //Buscar el document i comprovar si està "prestat"......
            buscarDocument();
            if (buscarPrestecDocument() == false)
            {
                DialogResult result = MessageBox.Show("El document no està en situació de préstec", "Devolució", MessageBoxButtons.OK, MessageBoxIcon.Error);
                nouDevolucio();
                txtId_document2.Focus();
                return;
            }

            //Correcte, busco el soci i activo la data retorn 
            buscarSoci();
            txtDataRetornPrestec2.Text = DateTime.Now.ToString("dd/MM/yyyy");
            txtDataRetornPrestec2.ReadOnly = false;
            acceptarButton2.Enabled = true;
            txtDataRetornPrestec2.Focus();


        }


        //***********************************************************************************************************
        // RENOVACIO
        private void txtId_document3_Leave(object sender, EventArgs e)
        {
            if (swsalir) return;
            if (txtId_document3.Text == "")
            {
                nouRenovacio();
                return;
            }

            if (validarNumero(txtId_document3.Text) == false)
            {
                DialogResult result = MessageBox.Show("ID DOCUMENT sols admet números", "Renovació", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtId_document3.Focus();
                return;
            }
            id_documentAct = Convert.ToInt32(txtId_document3.Text);
            if (clientWCF.existeixDocument(id_documentAct) == false)
            {
                txtTitol3.Text = "";
                txtFormat3.Text = "";
                DialogResult result = MessageBox.Show("Document inexistent", "Renovació", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtId_document3.Focus();
                return;
            }

            //Buscar el document i comprovar si està "prestat"......
            buscarDocument();
            if (buscarPrestecDocument() == false)
            {
                DialogResult result = MessageBox.Show("El document no està en situació de préstec", "Renovació", MessageBoxButtons.OK, MessageBoxIcon.Error);
                nouRenovacio();
                txtId_document3.Focus();
                return;
            }

            //Correcte, busco el soci i activo la data retorn 
            buscarSoci();
            txtDataFiPrestecNw3.ReadOnly = false;
            acceptarButton3.Enabled = true;
            txtDataFiPrestecNw3.Focus();

        }


        //***********************************************************************************************************
        private void nouPrestec()
        {
            txtId_document1.Text = "";
            txtTitol1.Text = "";
            txtFormat1.Text = "";
            txtId_soci1.Text = "";
            btnSociHelp1.Enabled = false;
            txtNom1.Text = "";
            txtDataIniciPrestec1.Text = DateTime.Now.ToString("dd/MM/yyyy");
            w_dataIniciPrestec = DateTime.Now;
            txtDataFiPrestec1.Text = "";
            txtId_soci1.ReadOnly = true;
            txtDataIniciPrestec1.ReadOnly = true;
            txtDataFiPrestec1.ReadOnly = true;
            acceptarButton1.Enabled = false;
        }

        //***********************************************************************************************************
        private void nouDevolucio()
        {
            txtId_document2.Text = "";
            txtId_prestec2.Text = "";
            txtTitol2.Text = "";
            txtFormat2.Text = "";
            txtId_soci2.Text = "";
            txtNom2.Text = "";
            txtDataIniciPrestec2.Text = "";
            txtDataFiPrestec2.Text = "";
            txtDataRetornPrestec2.Text = "";
            txtDataRetornPrestec2.ReadOnly = true;
            txtNumRenovacions2.Text = "";
            acceptarButton2.Enabled = false;
        }

        //***********************************************************************************************************
        private void nouRenovacio()
        {
            txtId_document3.Text = "";
            txtId_prestec3.Text = "";
            txtTitol3.Text = "";
            txtFormat3.Text = "";
            txtId_soci3.Text = "";
            txtNom3.Text = "";
            txtDataIniciPrestec3.Text = "";
            txtDataFiPrestec3.Text = "";
            txtDataFiPrestecNw3.Text = "";
            txtDataFiPrestecNw3.ReadOnly = true;
            txtNumRenovacions3.Text = "";
            acceptarButton3.Enabled = false;
        }


        //**********************************************************************************************************
        //Buscar la configuració
        private void buscarConfiguracio()
        {
            configuracioAct = clientWCF.buscarConfiguracio();
        }


        //**********************************************************************************************************
        //Buscar un document a la BD...
        private void buscarDocument()
        {
            documentAct = clientWCF.buscarDocument(id_documentAct);
            txtTitol1.Text = documentAct.titol;
            txtTitol2.Text = documentAct.titol;
            txtTitol3.Text = documentAct.titol;
            txtFormat1.Text = documentAct.id_format;
            txtFormat2.Text = documentAct.id_format;
            txtFormat3.Text = documentAct.id_format;

        }

        //**********************************************************************************************************
        //Buscar un prestec obert sobre un id_document
        private Boolean buscarPrestecDocument()
        {
            prestecAct = clientWCF.buscarPrestecIdDocument(id_documentAct);

            if (prestecAct == null) return false;     //No s'ha trobat cap registre --> no està prestat
            id_prestecAct = prestecAct.id_prestec;
            id_sociAct = prestecAct.id_soci;
            txtId_prestec2.Text = prestecAct.id_prestec.ToString();
            txtId_prestec3.Text = prestecAct.id_prestec.ToString();
            txtId_soci2.Text  = prestecAct.id_soci.ToString();
            txtId_soci3.Text = prestecAct.id_soci.ToString();
            txtDataIniciPrestec2.Text  = prestecAct.dataIniciPrestec.ToString("dd/MM/yyyy");
            txtDataFiPrestec2.Text  = prestecAct.dataFiPrestec.ToString("dd/MM/yyyy");
            txtDataIniciPrestec3.Text = prestecAct.dataIniciPrestec.ToString("dd/MM/yyyy");
            txtDataFiPrestec3.Text = prestecAct.dataFiPrestec.ToString("dd/MM/yyyy");
            txtNumRenovacions2.Text = prestecAct.numRenovacions.ToString();
            txtNumRenovacions3.Text = prestecAct.numRenovacions.ToString();
            return true;
        }

        //**********************************************************************************************************
        //Comprova si el document està disponible...
        private Boolean disponibleDocument()
        {
            if (documentAct.actiu == false) return false;
            if (documentAct.numUnitatsDisponibles == 0) return false;

            return true;
        }


        
        //*********************************************************************************************************+
        //Buscar un soci a la BD...
        private void buscarSoci()
        {
            sociAct = clientWCF.buscarSoci(id_sociAct);
            txtNom1.Text = sociAct.cognoms + ", " + sociAct.nom;
            txtNom2.Text = sociAct.cognoms + ", " + sociAct.nom;
            txtNom3.Text = sociAct.cognoms + ", " + sociAct.nom;

        }

        //*********************************************************************************************************+
        //Comprova si el soci pot fer préstecs...
        private Boolean disponibleSoci()
        {
            if (sociAct.actiu == false) return false;
            if (sociAct.esBaixa == true) return false;

            return true;
        }

        //*********************************************************************************************************+
        //Calcula la data de fi de prestec
        private void calcularDataFiPrestec()
        {
            DateTime w_data = new DateTime();
            w_data = DateTime.Parse(this.txtDataIniciPrestec1.Text);
            if (configuracioAct.diesPrestec == 30)
            {
                w_data = w_data.AddMonths(1);
            }
            else
            {
                w_data = w_data.AddDays(configuracioAct.diesPrestec);
            }
            txtDataFiPrestec1.Text  = w_data.ToString("dd/MM/yyyy");
        }

        //*********************************************************************************************************+
        //Calcula la nova data de fi de prestec per una renovació
        private void calcularRenovacio()
        {
            string data_x = "";
            data_x = clientWCF.calcularRenovacioPrestec(txtDataFiPrestec3.Text, configuracioAct.diesPrestec);
            txtDataFiPrestecNw3.Text = data_x;
        }
        
        //***********************************************************************************************************
        //  Gravar prestec a la BD
        private void acceptarButton1_Click(object sender, EventArgs e)
        {

            //Valida que els camps estiguin Ok...
            Boolean correcte = true;
            correcte = validarCamps1();
            if (!correcte)
            {
                return;
            }
            
            
            prestecsEntity prestecNou = new prestecsEntity();
            DateTime w_data = new DateTime();

            //Grava el nou préstec...
            prestecNou.id_document = id_documentAct;
            prestecNou.id_soci = id_sociAct;
            w_data = DateTime.Parse(this.txtDataIniciPrestec1.Text);
            prestecNou.dataIniciPrestec = w_data;
            w_data = DateTime.Parse(this.txtDataFiPrestec1.Text);
            prestecNou.dataFiPrestec = w_data;
            prestecNou.numRenovacions = 0;
            prestecNou.retornat = false;

            clientWCF.afegirPrestec(prestecNou);   

            //Posa les unitats disponibles a 0...
            clientWCF.canviarUnitatsDocument(id_documentAct, 0);

            DialogResult result = MessageBox.Show("Préstec registrat correctament" + System.Environment.NewLine + System.Environment.NewLine +
                                    "Document: " + txtId_document1.Text + " - " + txtTitol1.Text + System.Environment.NewLine + System.Environment.NewLine +
                                    "Soci: " + txtId_soci1.Text + " - " + txtNom1.Text + System.Environment.NewLine + System.Environment.NewLine +
                                    "Data fi préstec: " + txtDataFiPrestec1.Text,
                                    "Préstec", MessageBoxButtons.OK, MessageBoxIcon.Information);

            
            //Prepara un nou prestec...
            nouPrestec();
            txtId_document1.Focus();
        }

        //***********************************************************************************************************
        //  DEVOLUCIÓ Actualitzar prestec a la BD
        private void acceptarButton2_Click(object sender, EventArgs e)
        {
            //Valida que els camps estiguin Ok...
            Boolean correcte = true;
            correcte = validarCamps2();
            if (!correcte)
            {
                return;
            }
            
            prestecsEntity prestecNou = new prestecsEntity();
            DateTime w_data = new DateTime();
                         
            //Actualitza el préstec...
            w_data = DateTime.Parse(this.txtDataRetornPrestec2.Text);
            prestecAct.dataRetornPrestec = w_data;
            prestecAct.numRenovacions = 0;
            prestecAct.retornat = true;

            clientWCF.modificarPrestec(prestecAct);

            //Posa les unitats disponibles a 1...
            clientWCF.canviarUnitatsDocument(id_documentAct, 1);

            DialogResult result = MessageBox.Show("Devolució registrada correctament" + System.Environment.NewLine + System.Environment.NewLine +
                                    "Document: " + txtId_document2.Text + " - " + txtTitol2.Text + System.Environment.NewLine + System.Environment.NewLine +
                                    "Soci: " + txtId_soci2.Text + " - " + txtNom2.Text + System.Environment.NewLine + System.Environment.NewLine +
                                    "Data devolució: " + txtDataRetornPrestec2.Text,
                                    "Devolució", MessageBoxButtons.OK, MessageBoxIcon.Information);


            //Prepara un nou prestec...
            nouDevolucio();
            txtId_document2.Focus();
        }

        //***********************************************************************************************************
        //  RENOVACIÓ Actualitzar prestec a la BD
        private void acceptarButton3_Click(object sender, EventArgs e)
        {
            //Valida que els camps estiguin Ok...
            Boolean correcte = true;
            correcte = validarCamps3();
            if (!correcte)
            {
                return;
            }
            
            if (prestecAct.numRenovacions == 2)
            {
                DialogResult result1 = MessageBox.Show("No es podem fer més de 2 renovacions", "Renovació", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                txtDataFiPrestecNw3.Focus();
                return;
            }

            if (String.IsNullOrEmpty(txtDataFiPrestecNw3.Text) == true)
            {
                DialogResult result1 = MessageBox.Show("No ha introduit cap data de renovació", "Renovació", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                txtDataFiPrestecNw3.Focus();
                return;
            }


            
            prestecsEntity prestecNou = new prestecsEntity();
            DateTime w_data = new DateTime();

            //Actualitza el préstec...
            w_data = DateTime.Parse(txtDataFiPrestecNw3.Text);
            prestecAct.dataFiPrestec = w_data;

            prestecAct.numRenovacions = Convert.ToInt32(txtNumRenovacions3.Text) + 1;
            clientWCF.modificarPrestec(prestecAct);

            DialogResult result2 = MessageBox.Show("Renovació registrada correctament" + System.Environment.NewLine + System.Environment.NewLine +
                                    "Document: " + txtId_document3.Text + " - " + txtTitol3.Text + System.Environment.NewLine + System.Environment.NewLine +
                                    "Soci: " + txtId_soci3.Text + " - " + txtNom3.Text + System.Environment.NewLine + System.Environment.NewLine +
                                    "Nova data fi préstec: " + txtDataFiPrestecNw3.Text ,
                                    "Renovació", MessageBoxButtons.OK, MessageBoxIcon.Information);
            
            //Prepara un nou prestec...
            nouRenovacio();
            txtId_document3.Focus();
        }

        //***********************************************************************************************************
        private void tabControl1_Selecting(object sender, TabControlCancelEventArgs e)
        {
            swsalir = false;
            nouPrestec();
            nouDevolucio();
            nouRenovacio();

            if (tabControl1.SelectedIndex == 0) txtId_document1.Focus();
            if (tabControl1.SelectedIndex == 1) txtId_document2.Focus();
            if (tabControl1.SelectedIndex == 2) txtId_document3.Focus();
        }

        //***********************************************************************************************************
        private void tabControl1_Selected(object sender, TabControlEventArgs e)
        {
            if (tabControl1.SelectedIndex == 0) txtId_document1.Focus();
            if (tabControl1.SelectedIndex == 1) txtId_document2.Focus();
            if (tabControl1.SelectedIndex == 2) txtId_document3.Focus();
        }

        //***********************************************************************************************************
        private void renovarButton3_Click(object sender, EventArgs e)
        {
            int numero = 0;
            numero = Convert.ToInt32(txtNumRenovacions3.Text);
            if (numero == 2)
            {
                DialogResult result = MessageBox.Show("No es poden fer més de dos renovacions", "Renovació", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return;
            }
            calcularRenovacio();

        }

        
        //***********************************************************************************************************
        private void cancelarButton1_Click(object sender, EventArgs e)
        {
            swsalir = true;
            gblParametres parametres = gblParametres.Instance();
            parametres.frm4Prestec = 0;

            this.Dispose();
        }

        //***********************************************************************************************************
        private void cancelarButton2_Click(object sender, EventArgs e)
        {
            swsalir = true;
            gblParametres parametres = gblParametres.Instance();
            parametres.frm4Prestec = 0;
            this.Dispose();
        }

        //***********************************************************************************************************
        private void cancelarButton3_Click(object sender, EventArgs e)
        {
            swsalir = true;
            gblParametres parametres = gblParametres.Instance();
            parametres.frm4Prestec = 0;
            this.Dispose();
        }

        //***********************************************************************************************************
        private void frm4Prestec_FormClosing(object sender, FormClosingEventArgs e)
        {
            swsalir = true;
            gblParametres parametres = gblParametres.Instance();
            parametres.frm4Prestec = 0;
        }


        //***********************************************************************************************************
        private Boolean validarNumero(string numero)
        {
            int number = 0;

            if (String.IsNullOrEmpty(numero) == true) return false;
            if (int.TryParse(numero.Trim(), out number) == false) return false;
            if (Convert.ToInt32(numero) == 0) return false;

            return true;
        }

        //*********************************************************************************************************+
        //Validar data
        private Boolean isDate(string data)
        {
            DateTime dateparse;
            if (DateTime.TryParseExact(data, "dd/MM/yyyy", CultureInfo.InvariantCulture, DateTimeStyles.None, out dateparse)) return true;
            return false;
        }


        //*********************************************************************************************************+
        // PRESTEC
        //    Obrir finestra ajuda documents
        private void btnDocumentHelp1_Click(object sender, EventArgs e)
        {
            frm2DocumentHelp f = new frm2DocumentHelp();
            f.WindowState = FormWindowState.Normal;
            f.ShowDialog();

            //Valor retornat...
            if (f.id_document != 0)
            {
                id_documentAct = f.id_document;
                txtId_document1.Text = id_documentAct.ToString();
                buscarDocument();
                txtId_document1.Focus();
            }
            f.Close();
        }

        //*********************************************************************************************************+
        // PRESTEC
        //    Obrir finestra ajuda socis
        private void btnSociHelp1_Click(object sender, EventArgs e)
        {
            frm3SociHelp f = new frm3SociHelp();
            f.WindowState = FormWindowState.Normal;
            f.ShowDialog();

            //Valor retornat...
            if (f.id_soci != 0)
            {
                id_sociAct = f.id_soci;
                txtId_soci1.Text = id_sociAct.ToString();
                buscarSoci();
                txtId_soci1.Focus();
            }
            f.Close();

        }

        //*********************************************************************************************************+
        // DEVOLUCIO
        //    Obrir finestra ajuda documents
        private void btnDocumentHelp2_Click(object sender, EventArgs e)
        {
            frm2DocumentHelp f = new frm2DocumentHelp();
            f.WindowState = FormWindowState.Normal;
            f.ShowDialog();

            //Valor retornat...
            if (f.id_document != 0)
            {
                id_documentAct = f.id_document;
                txtId_document2.Text = id_documentAct.ToString();
                buscarDocument();
                txtId_document2.Focus();
            }
            f.Close();

        }

        //*********************************************************************************************************+
        // RENOVACIO
        //    Obrir finestra ajuda documents
        private void btnDocumentHelp3_Click(object sender, EventArgs e)
        {
            frm2DocumentHelp f = new frm2DocumentHelp();
            f.WindowState = FormWindowState.Normal;
            f.ShowDialog();

            //Valor retornat...
            if (f.id_document != 0)
            {
                id_documentAct = f.id_document;
                txtId_document3.Text = id_documentAct.ToString();
                buscarDocument();
                txtId_document3.Focus();
            }
            f.Close();

        }

        //*********************************************************************************************************+
        // VALIDAR CAMPS-1 
        //    Préstec
        private Boolean validarCamps1()
        {
            //Validar dates...
            if (String.IsNullOrEmpty(txtDataIniciPrestec1.Text) == true)
            {
                DialogResult result = MessageBox.Show("Falta informar DATA INICI PRÉSTEC", "Préstec", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtDataIniciPrestec1.Focus();
                return false;
            }
            if (String.IsNullOrEmpty(txtDataIniciPrestec1.Text) == false)
            {
                if (this.isDate(txtDataIniciPrestec1.Text) == false)
                {
                    DialogResult result = MessageBox.Show("DATA INICI PRÉSTEC Incorrecte" + System.Environment.NewLine + System.Environment.NewLine + "Format: dd/mm/aaaa", "Soci", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    txtDataIniciPrestec1.Focus();
                    return false;
                }
            }

            if (String.IsNullOrEmpty(txtDataFiPrestec1.Text) == true)
            {
                DialogResult result = MessageBox.Show("Falta informar DATA FI PRÉSTEC", "Préstec", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtDataFiPrestec1.Focus();
                return false;
            }
            if (String.IsNullOrEmpty(txtDataFiPrestec1.Text) == false)
            {
                if (this.isDate(txtDataFiPrestec1.Text) == false)
                {
                    DialogResult result = MessageBox.Show("DATA FI PRÉSTEC Incorrecte" + System.Environment.NewLine + System.Environment.NewLine + "Format: dd/mm/aaaa", "Préstec", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    txtDataFiPrestec1.Focus();
                    return false;
                }
            }


            //Validar data inici/devolució Prestec
            DateTime w_data1;
            DateTime w_data2;

            w_data1 = DateTime.Parse(this.txtDataIniciPrestec1.Text);
            w_data2 = DateTime.Parse(this.txtDataFiPrestec1.Text);
            if (w_data1 > w_data2)
            {
                DialogResult result = MessageBox.Show("DATA FI PRESTEC ha de ser posterior a la data d'inici", "Préstec", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtDataFiPrestec1.Focus();
                return false;
            }
            
            //Correcte
            return true;

        }

        //*********************************************************************************************************+
        // VALIDAR CAMPS-2 
        //    Devolució
        private Boolean validarCamps2()
        {
            
            //Validar dates...
            if (String.IsNullOrEmpty(txtDataRetornPrestec2.Text) == true)
            {
                DialogResult result = MessageBox.Show("Falta informar DATA DEVOLUCIÓ PRÉSTEC", "Devolució", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtDataRetornPrestec2.Focus();
                return false;
            }
            if (String.IsNullOrEmpty(txtDataRetornPrestec2.Text) == false)
            {
                if (this.isDate(txtDataRetornPrestec2.Text) == false)
                {
                    DialogResult result = MessageBox.Show("DATA DEVOLUCIÓ PRÉSTEC Incorrecte" + System.Environment.NewLine + System.Environment.NewLine + "Format: dd/mm/aaaa", "Devolució", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    txtDataRetornPrestec2.Focus();
                    return false;
                }
            }


            //Validar data inici/devolució Prestec
            DateTime w_data1;
            DateTime w_data2;

            w_data1 = DateTime.Parse(this.txtDataIniciPrestec2.Text);
            w_data2 = DateTime.Parse(this.txtDataRetornPrestec2.Text);
            if (w_data1 > w_data2)
            {
                DialogResult result = MessageBox.Show("DATA DEVOLUCIÓ PRESTEC ha de ser posterior a la data d'inici", "Devolució", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtDataRetornPrestec2.Focus();
                return false;
            }

            //Correcte
            return true;

        }

        //*********************************************************************************************************+
        // VALIDAR CAMPS-3
        //    Renovació
        private Boolean validarCamps3()
        {
            //Validar dates...
            if (String.IsNullOrEmpty(txtDataFiPrestecNw3.Text) == true)
            {
                DialogResult result = MessageBox.Show("Falta informar NOVA DATA FI PRÉSTEC", "Renovació", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtDataFiPrestecNw3.Focus();
                return false;
            }
            if (String.IsNullOrEmpty(txtDataFiPrestecNw3.Text) == false)
            {
                if (this.isDate(txtDataFiPrestecNw3.Text) == false)
                {
                    DialogResult result = MessageBox.Show("NOVA DATA FI PRÉSTEC Incorrecte" + System.Environment.NewLine + System.Environment.NewLine + "Format: dd/mm/aaaa", "Renovació", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    txtDataFiPrestecNw3.Focus();
                    return false;
                }
            }


            //Validar data inici/devolució Prestec
            DateTime w_data1;
            DateTime w_data2;

            w_data1 = DateTime.Parse(this.txtDataIniciPrestec3.Text);
            w_data2 = DateTime.Parse(this.txtDataFiPrestecNw3.Text);
            if (w_data1 > w_data2)
            {
                DialogResult result = MessageBox.Show("NOVA DATA FI PRESTEC ha de ser posterior a la data d'inici", "Devolució", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtDataFiPrestecNw3.Focus();
                return false;
            }

            //Correcte
            return true;

        }
    
    
    
    }//fi classe
}//fi namespace
