﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Globalization;
using Negoci;
using Terminal.ServiceReference1;
using NegociEntitats;

namespace Terminal
{
    public partial class frm4PrestecFitxa : Form
    {
        private ServiceReference1.Service1Client clientWCF = new ServiceReference1.Service1Client(); // Instancia del servei WCF
        //private simulawcfCN clientWCF = new simulawcfCN(); // simula WCF
        
        private prestecsEntity prestecAct = new prestecsEntity();
        private int id_prestecAct = 0;
        private Boolean retornatAnt;

         
        //********************************************************************************************
        public frm4PrestecFitxa(int id_prestec)
        {
            InitializeComponent();
            id_prestecAct = id_prestec;
        }

        //********************************************************************************************
        private void frm2Document_Load(object sender, EventArgs e)
        {
            buscarPrestec();

            moureCamps_a_Pantalla();

        }

        //********************************************************************************************
        private void acceptarButton_Click(object sender, EventArgs e)
        {
            //Valida que els camps estiguin Ok...
            Boolean correcte = true;
            correcte = validarCamps();
            if (!correcte)
            {
                return;
            }

            moureCamps();
            modificarPrestec();

            if (retornatAnt != prestecAct.retornat)
            {
                DialogResult result = MessageBox.Show("Has canviat la situació de RETORNAT d'un prestec" + System.Environment.NewLine + System.Environment.NewLine + 
                                                      "Recorda modificar el document d'acord amb els canvis realitzats !!" + System.Environment.NewLine + System.Environment.NewLine + 
                                                      "(num. unitats disponibles)" ,
                                                      "Préstec", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            this.Dispose();
        }

        //********************************************************************************************
        private void eliminarButton_Click(object sender, EventArgs e)
        {
            DialogResult result = MessageBox.Show("Confirmar l'eliminació", "Eliminar Prestec", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);

            if (result == DialogResult.OK)
            {
                eliminarPrestec();
                this.Dispose();
            }
        }

        private void cancelarButton_Click(object sender, EventArgs e)
        {
            this.Dispose();
        }


        //*********************************************************************************************************+
        //Validar els camps introduits...
        private Boolean validarCamps()
        {
            Boolean correcte = true;
            DateTime w_data1;
            DateTime w_data2;


            //Validar data inici Prestec
            if (String.IsNullOrEmpty(txtDataIniciPrestec.Text) == true)
            {
                DialogResult result = MessageBox.Show("Faltar informar DATA INICI PRÉSTEC", "Préstec", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtDataIniciPrestec.Focus();
                return false;
            }
            if (String.IsNullOrEmpty(txtDataIniciPrestec.Text) == false)
            {
                if (this.isDate(txtDataIniciPrestec.Text) == false)
                {
                    DialogResult result = MessageBox.Show("DATA INICI PRÉSTEC Incorrecte" + System.Environment.NewLine + System.Environment.NewLine + "Format: dd/mm/aaaa", "Soci", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    txtDataIniciPrestec.Focus();
                    return false;
                }
            
            }

            //Validar data fi Prestec
            if (String.IsNullOrEmpty(txtDataFiPrestec.Text) == true)
            {
                DialogResult result = MessageBox.Show("Faltar informar DATA FI PRÉSTEC", "Préstec", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtDataFiPrestec.Focus();
                return false;
            }
            if (String.IsNullOrEmpty(txtDataFiPrestec.Text) == false)
            {
                if (this.isDate(txtDataFiPrestec.Text) == false)
                {
                    DialogResult result = MessageBox.Show("DATA FI PRÉSTEC Incorrecte" + System.Environment.NewLine + System.Environment.NewLine + "Format: dd/mm/aaaa", "Soci", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    txtDataFiPrestec.Focus();
                    return false;
                }

            }

            //Validar data retorn Prestec
            if (String.IsNullOrEmpty(txtDataRetornPrestec.Text) == false)
            {
                if (this.isDate(txtDataRetornPrestec.Text) == false)
                {
                    DialogResult result = MessageBox.Show("DATA DEVOLUCIÓ PRÉSTEC Incorrecte" + System.Environment.NewLine + System.Environment.NewLine + "Format: dd/mm/aaaa", "Préstec", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    txtDataRetornPrestec.Focus();
                    return false;
                }

            }

            //Validar data inici/fi Prestec
            w_data1 = DateTime.Parse(this.txtDataIniciPrestec.Text);
            w_data2 = DateTime.Parse(this.txtDataFiPrestec.Text);
            if (w_data1 > w_data2)
            {
                DialogResult result = MessageBox.Show("DATA FI PRESTEC ha de ser posterior a la data d'inici", "Préstec", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtDataFiPrestec.Focus();
                return false;
            }

            //Validar data inici/devolució Prestec
            if (String.IsNullOrEmpty(txtDataRetornPrestec.Text) == false)
            {
                w_data1 = DateTime.Parse(this.txtDataIniciPrestec.Text);
                w_data2 = DateTime.Parse(this.txtDataRetornPrestec.Text);
                if (w_data1 > w_data2)
                {
                    DialogResult result = MessageBox.Show("DATA DEVOLUCIÓ PRESTEC ha de ser posterior a la data d'inici", "Préstec", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    txtDataRetornPrestec.Focus();
                    return false;
                }
            }



            //Validar numRenovacions
            if (String.IsNullOrEmpty(txtNumRenovacions.Text) == false)
            {
                if (this.isNumeric(txtNumRenovacions.Text) == false)
                {
                    DialogResult result = MessageBox.Show("NUM.RENOVACIONS sols admet números", "Préstec", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    txtNumRenovacions.Focus();
                    return false;
                }
                if (Convert.ToInt32(txtNumRenovacions.Text ) > 2)
                {
                    DialogResult result = MessageBox.Show("Sols és permeten dues renovacions", "Préstec", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    txtNumRenovacions.Focus();
                    return false;
                }
            }
            
            //Validar retornat...
            if (chkRetornat.Checked == true)
            {
                if (String.IsNullOrEmpty(txtDataRetornPrestec.Text) == true)
                {
                    DialogResult result = MessageBox.Show("Si el prestec està retornat, ha de ternir informada la DATA DEVOLUCIÓ" + System.Environment.NewLine + System.Environment.NewLine + "Format: dd/mm/aaaa", "Préstec", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    txtDataRetornPrestec.Focus();
                    return false;
                }

            }


            //Retorn
            return correcte;
        }

        //*********************************************************************************************************+
        //Mou els camps a la pantalla ...
        private void moureCamps_a_Pantalla()
        {
            txtId_prestec.Text = prestecAct.id_prestec.ToString();
            txtId_document.Text = prestecAct.id_document.ToString();
            txtTitol.Text = prestecAct.titol;
            txtFormat.Text = prestecAct.id_format;
            txtId_soci.Text = prestecAct.id_soci.ToString();
            txtNom.Text = prestecAct.cognoms + ", " + prestecAct.nom;
            txtDataIniciPrestec.Text = prestecAct.dataIniciPrestec.ToString("dd/MM/yyyy");
            txtDataFiPrestec.Text = prestecAct.dataFiPrestec.ToString("dd/MM/yyyy");
            txtDataRetornPrestec.Text = prestecAct.dataRetornPrestec.ToString("dd/MM/yyyy");
            if (txtDataRetornPrestec.Text == "01/01/0001") txtDataRetornPrestec.Text = "";
            txtNumRenovacions.Text = prestecAct.numRenovacions.ToString();
            chkRetornat.Checked = prestecAct.retornat;
            if (prestecAct.retornat == false) txtDataRetornPrestec.Text = "";

        }


        //*********************************************************************************************************+
        //Mou els camps desde pantalla ...
        private void moureCamps()
        {
            DateTime w_data = new DateTime();
            w_data = DateTime.Parse(txtDataIniciPrestec.Text);
            prestecAct.dataIniciPrestec = w_data;
            w_data = DateTime.Parse(txtDataFiPrestec.Text);
            prestecAct.dataFiPrestec = w_data;
            if (String.IsNullOrEmpty(txtDataRetornPrestec.Text) == false)
            {
                w_data = DateTime.Parse(txtDataRetornPrestec.Text);
            }
            prestecAct.numRenovacions = Convert.ToInt32(txtNumRenovacions.Text);
            prestecAct.retornat = chkRetornat.Checked;
        }

        //*********************************************************************************************************+
        //Buscar un prestec a la BD...
        private void buscarPrestec()
        {
            prestecAct = clientWCF.buscarPrestec(id_prestecAct);
            retornatAnt = prestecAct.retornat;
        }


        //*********************************************************************************************************+
        //Modificar prestec de la BD...
        private void modificarPrestec()
        {
            clientWCF.modificarPrestec(prestecAct);
        }

        //*********************************************************************************************************+
        //Eliminar prestec de la BD...
        private void eliminarPrestec()
        {
            clientWCF.eliminarPrestec(id_prestecAct);
        }

        //*********************************************************************************************************+
        //Validar data
        private Boolean isDate(string data)
        {
            DateTime dateparse;
            if (DateTime.TryParseExact(data, "dd/MM/yyyy", CultureInfo.InvariantCulture, DateTimeStyles.None, out dateparse)) return true;
            return false;
        }

        //*********************************************************************************************************+
        //Validar numero
        private Boolean isNumeric(string numero)
        {
            int number=0;
            if (int.TryParse(numero.Trim(), out number) ) return true;
            return false;
        }



    }//fi class
}//fi namespace
