﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Negoci;
using Terminal.ServiceReference1;
using NegociEntitats;


namespace Terminal
{
    public partial class frm4PrestecVer : Form
    {
        private ServiceReference1.Service1Client clientWCF = new ServiceReference1.Service1Client(); // Instancia del servei WCF
        //private simulawcfCN clientWCF = new simulawcfCN(); // simula WCF

        private List<prestecsEntity> ListPrestecs;
        private string w_opcioCercar = "";

        public frm4PrestecVer()
        {
            InitializeComponent();

        }

        private void btnSortir_Click(object sender, EventArgs e)
        {
            gblParametres parametres = gblParametres.Instance();
            parametres.frm4PrestecVer = 0;
            this.Dispose();
        }

        //Cargar formulari...
        private void frm2DocumentVer_Load(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Maximized;
            txtCercar.Text = "";
            cmbCercar.SelectedIndex = 3;
        }


        //****************************************************************************************
        private void btnModificar_Click(object sender, EventArgs e)
        {
            //Comprovem si hi ha quelcom a la llista...
            if (gridPrestecs.RowCount == 0)
            {
                return; 
            }
            //recuperem la linea sel.lecionada

            DataGridViewRow row = this.gridPrestecs.CurrentRow;
            int id_prestec = 0;
            id_prestec = Convert.ToInt32(row.Cells[0].Value);
            //modificar ....
            frm4PrestecFitxa f = new frm4PrestecFitxa(id_prestec);
            f.WindowState = FormWindowState.Normal;
            f.ShowDialog();

            //Refresca el grid, per si hi han canvis...
            cercarDadesGrid();

        }
        //****************************************************************************************
        private void chkPendents_Click(object sender, EventArgs e)
        {
            if (chkPendents.Checked == true)
            {
                cmbCercar.Enabled = false;
                txtCercar.Enabled = false;
                btnCercar.Enabled = false;
            }
            if (chkPendents.Checked == false) 
            {
                cmbCercar.Enabled = true;
                txtCercar.Enabled = true;
                btnCercar.Enabled = true;
            }

        }

        //****************************************************************************************
        private void btnVeureTots_Click(object sender, EventArgs e)
        {
            txtCercar.Text  = "";
            cmbCercar.SelectedIndex = 0;
            w_opcioCercar = "veuretots";
            if (chkPendents.Checked == true) w_opcioCercar = "veurependents";
            cercarDadesGrid();
        }

        //****************************************************************************************
        private void btnCercar_Click(object sender, EventArgs e)
        {
            Boolean correcte = true;
            correcte = validarCamps();

            if (!correcte) 
            {
                return;
            }

            w_opcioCercar = "cercar";
            cercarDadesGrid();

        }

        //****************************************************************************************
        //Validar els camps introduits...
        private Boolean validarCamps()
        {
            Boolean correcte = true;

            //No s'ha introduit res per cercar...
            if (String.IsNullOrEmpty(txtCercar.Text))
            {
                correcte = false;
            }

            //Valida l'entrada que sigui numeric...
            int number = 0;
            txtCercar.Text = txtCercar.Text.Trim();
            if (String.IsNullOrEmpty(txtCercar.Text) == false)
            {
                if (cmbCercar.SelectedIndex <= 2)
                {
                    if (int.TryParse(txtCercar.Text.Trim(), out number) == false)
                    {
                        DialogResult result = MessageBox.Show("Introduir sols números per buscar per un Id", "Consulta préstecs", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        correcte = false;
                    }
                }
            }

            return correcte;
        }

        //****************************************************************************************
        // Buscar dades per ficar al Datagrid...
        private void cercarDadesGrid()
        {
            //Esborrar grid...
            gridPrestecs.DataSource = null;
            gridPrestecs.Rows.Clear();
            gridPrestecs.ClearSelection();

            //Botó VeureTots...
            if (w_opcioCercar == "veuretots")
            {
                ListPrestecs = clientWCF.llistarPrestecs(1, "").ToList();
            }

            //Botó VeureTots+pendentes retornar...
            if (w_opcioCercar == "veurependents")
            {
                ListPrestecs = clientWCF.llistarPrestecs(7, "").ToList();
            }

            //Botó Cercar...
            if (w_opcioCercar == "cercar")
            {
                //El index del combo+2 indica el tipus de cerca per llistarPrestecs
                // 1=tots, 2=id prestec, 3=id document, 4=id soci, 5=titol, 6=nom soci, 7=pendets retornar
                if (String.IsNullOrEmpty(txtCercar.Text) == false)
                {
                     int selectedIndex = cmbCercar.SelectedIndex;
                     selectedIndex += 2;
                     ListPrestecs = clientWCF.llistarPrestecs(selectedIndex, txtCercar.Text).ToList();
                 }
            }

            //carregar el grid...
            carregarGrid();

        }


        //****************************************************************************************
        // Carrega la llista al datagridView .....
        private void carregarGrid()
        {
            Boolean llistaBuida = false;
            if (ListPrestecs == null) llistaBuida = true;
            if (!llistaBuida)
            {
                if (ListPrestecs.Count == 0) llistaBuida = true;
            }
            if (llistaBuida)
            {
                DialogResult nada = MessageBox.Show("No hi han préstecs que compleixin les condicions de cerca", "Consulta préstecs", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return;
            }

            //Passar la llista de documents obtinguda al grid...
            for (int i = 0; i < ListPrestecs.Count(); i++)
            {

                gridPrestecs.Rows.Add();
                gridPrestecs.Rows[i].Cells[0].Value = ListPrestecs.ElementAt(i).id_prestec;
                gridPrestecs.Rows[i].Cells[1].Value = ListPrestecs.ElementAt(i).id_document;
                gridPrestecs.Rows[i].Cells[2].Value = ListPrestecs.ElementAt(i).titol;
                gridPrestecs.Rows[i].Cells[3].Value = ListPrestecs.ElementAt(i).id_format;
                gridPrestecs.Rows[i].Cells[4].Value = ListPrestecs.ElementAt(i).dataIniciPrestec.ToString("dd/MM/yyyy");
                gridPrestecs.Rows[i].Cells[5].Value = ListPrestecs.ElementAt(i).dataFiPrestec.ToString("dd/MM/yyyy");
                gridPrestecs.Rows[i].Cells[6].Value = ListPrestecs.ElementAt(i).dataRetornPrestec.ToString("dd/MM/yyyy");
                if (ListPrestecs.ElementAt(i).dataRetornPrestec.ToString("dd/MM/yyyy") == "01/01/0001")
                {
                    gridPrestecs.Rows[i].Cells[6].Value = " ";
                }
                gridPrestecs.Rows[i].Cells[7].Value = ListPrestecs.ElementAt(i).id_soci;
                gridPrestecs.Rows[i].Cells[8].Value = ListPrestecs.ElementAt(i).cognoms + ", " + ListPrestecs.ElementAt(i).nom;

                if (ListPrestecs.ElementAt(i).retornat == false)
                {
                    gridPrestecs.Rows[i].Cells[6].Value = " ";
                }
            }

            gridPrestecs.Refresh();

        }

        //****************************************************************************************
        private void gridPrestecs_DoubleClick(object sender, EventArgs e)
        {
            btnModificar_Click(sender, e);
        }

        //****************************************************************************************
        private void frm4PrestecVer_FormClosing(object sender, FormClosingEventArgs e)
        {
            gblParametres parametres = gblParametres.Instance();
            parametres.frm4PrestecVer = 0;
        }




    } //fi classe
} //fi namepace
