﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Globalization;
using Negoci;
using Terminal.ServiceReference1;
using NegociEntitats;

namespace Terminal
{
    public partial class frm5Configuracio : Form
    {
        private ServiceReference1.Service1Client clientWCF = new ServiceReference1.Service1Client(); // Instancia del servei WCF
        //private simulawcfCN clientWCF = new simulawcfCN(); // simula WCF
        
        private configuracioEntity configuracioAct = new configuracioEntity();
         
        public frm5Configuracio()
        {
            InitializeComponent();
        }

        private void frm5Configuracio_Load(object sender, EventArgs e)
        {
            buscarConfiguracio();
            moureCamps_a_Pantalla();

        }

        private void acceptarButton_Click(object sender, EventArgs e)
        {
            //Valida que els camps estiguin Ok...
            Boolean correcte = true;
            correcte = validarCamps();
            if (!correcte)
            {
                return;
            }


            moureCamps();
            modificarConfiguracio();

            gblParametres parametres = gblParametres.Instance();
            parametres.frm5Configuracio = 0;

            this.Dispose();
        }

        //********************************************************************************************
        private void cancelarButton_Click(object sender, EventArgs e)
        {

            if (validarContrasenyes()== false) return;
            
            gblParametres parametres = gblParametres.Instance();
            parametres.frm5Configuracio = 0;

            this.Dispose();
        }


        //*********************************************************************************************************+
        //Validar els camps introduits...
        private Boolean validarCamps()
        {
            int numero=0;

            //Validar nom 
            if (String.IsNullOrEmpty(txtNomBiblioteca.Text) == true)
            {
                DialogResult result = MessageBox.Show("Faltar NOM BIBLIOTECA", "Configuració", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtNomBiblioteca.Focus();
                return false;
            }

            //Validar email...
            if (String.IsNullOrEmpty(txtEmailBiblioteca.Text) == false)
            {
                txtEmailBiblioteca.Text = txtEmailBiblioteca.Text.Trim();

                if (txtEmailBiblioteca.Text.IndexOf("@") < 1 || txtEmailBiblioteca.Text.IndexOf(".") < 3 || txtEmailBiblioteca.Text.Length < 5)
                {
                    DialogResult result = MessageBox.Show("EMAIL no te un format correcte  xxxxx@xxxxx.xxx", "Confifuració", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    txtEmailBiblioteca.Text = configuracioAct.emailBiblioteca;
                    txtEmailBiblioteca.Focus();
                    return false;
                }
            }




            //Validar diesprestec
            if (isNumeric(txtDiesPrestec.Text) == false)
            {
                DialogResult result = MessageBox.Show("DIES PRESTEC sols admet números", "Document", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtDiesPrestec.Focus();
                return false;
            }
            numero = Convert.ToInt32(txtDiesPrestec.Text);
            if (numero < 1 || numero > 365)
            {
                DialogResult result = MessageBox.Show("DIES PRESTEC ha d'estar entre 1 i 365 dies", "Document", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtDiesPrestec.Focus();
                return false;
            }

            //Validar docsprestec
            if (isNumeric(txtDocsPrestec.Text) == false)
            {
                DialogResult result = MessageBox.Show("MAX.DOCUMENTS EN PRESTEC sols admet números", "Document", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtDocsPrestec.Focus();
                return false;
            }
            numero = Convert.ToInt32(txtDocsPrestec.Text);
            if (numero < 1 || numero > 10)
            {
                DialogResult result = MessageBox.Show("MAX.DOCUMENTS EN PRESTEC ha d'estar entre 1 i 10 documents", "Document", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtDiesPrestec.Focus();
                return false;
            }


            //Validar contrasenyes... Retorn
            return validarContrasenyes();

        }

        //*********************************************************************************************************+
        //Mou els camps a la pantalla ...
        private void moureCamps_a_Pantalla()
        {
            txtNomBiblioteca.Text = configuracioAct.nomBiblioteca;
            txtAdrecaBiblioteca.Text = configuracioAct.adrecaBiblioteca;
            txtCpBiblioteca.Text = configuracioAct.cpBiblioteca;
            txtPoblacioBiblioteca.Text = configuracioAct.poblacioBiblioteca;
            txtTelefonBiblioteca.Text = configuracioAct.telefonBiblioteca;
            txtEmailBiblioteca.Text = configuracioAct.emailBiblioteca;
            txtDiesPrestec.Text = configuracioAct.diesPrestec.ToString();
            txtDocsPrestec.Text = configuracioAct.docsPrestec.ToString();
            txtPswAdministrador.Text = configuracioAct.pswAdministrador;
            txtPswUsuari.Text = configuracioAct.pswUsuari;
            chkVeureContrasenyes.Checked = false;

            lblPswAdministrador.Visible = false;
            if (String.IsNullOrEmpty(configuracioAct.pswAdministrador) == true)
            {
                lblPswAdministrador.Visible = true;
            }
            lblPswUsuari.Visible = false;
            if (String.IsNullOrEmpty(configuracioAct.pswUsuari) == true)
            {
                lblPswUsuari.Visible = true;
            }

        }


        //*********************************************************************************************************+
        //Mou els camps desde pantalla ...
        private void moureCamps()
        {
            configuracioAct.nomBiblioteca = txtNomBiblioteca.Text;
            configuracioAct.adrecaBiblioteca = txtAdrecaBiblioteca.Text;
            configuracioAct.cpBiblioteca = txtCpBiblioteca.Text;
            configuracioAct.poblacioBiblioteca = txtPoblacioBiblioteca.Text;
            configuracioAct.telefonBiblioteca = txtTelefonBiblioteca.Text;
            configuracioAct.emailBiblioteca = txtEmailBiblioteca.Text;
            configuracioAct.diesPrestec = Convert.ToInt32(txtDiesPrestec.Text);
            configuracioAct.docsPrestec = Convert.ToInt32(txtDocsPrestec.Text);
            configuracioAct.pswAdministrador = txtPswAdministrador.Text;
            configuracioAct.pswUsuari = txtPswUsuari.Text;

        }

        //*********************************************************************************************************+
        //Buscar la configuració a la BD...
        private void buscarConfiguracio()
        {
            configuracioAct = clientWCF.buscarConfiguracio();
        }


        //*********************************************************************************************************+
        //Modificar la configuració de la BD...
        private void modificarConfiguracio()
        {
            clientWCF.modificarConfiguracio(configuracioAct);
        }

        //*********************************************************************************************************+
        // ensenyar/amagar les contrasenyes
        private void chkVeureContrasenyes_CheckedChanged(object sender, EventArgs e)
        {
            if (chkVeureContrasenyes.Checked == true)
            {
                txtPswAdministrador.PasswordChar = char.Parse("\0");
                txtPswUsuari.PasswordChar = char.Parse("\0");

            }
            else
            {
                txtPswAdministrador.PasswordChar = char.Parse("*");
                txtPswUsuari.PasswordChar = char.Parse("*");
            }
        }


        //*********************************************************************************************************+
        private void txtPswAdministrador_TextChanged(object sender, EventArgs e)
        {
            if (String.IsNullOrEmpty(txtPswAdministrador.Text) == true)
            {
                lblPswAdministrador.Visible = true;
            }
            else
            {
                lblPswAdministrador.Visible = false;
            }
        }

        //*********************************************************************************************************+
        private void txtPswUsuari_TextChanged(object sender, EventArgs e)
        {
            if (String.IsNullOrEmpty(txtPswUsuari.Text) == true)
            {
                lblPswUsuari.Visible = true;
            }
            else
            {
                lblPswUsuari.Visible = false;
            }
        }



        //*********************************************************************************************************+
        //Validar numero
        private Boolean isNumeric(string numero)
        {
            int number = 0;
            if (int.TryParse(numero.Trim(), out number)) return true;
            return false;
        }

        //*********************************************************************************************************+
        private void frm5Configuracio_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (validarContrasenyes() == false)
            {
                e.Cancel = true;
            }
            
            gblParametres parametres = gblParametres.Instance();
            parametres.frm5Configuracio = 0;
        }

        //*********************************************************************************************************+
        private Boolean validarContrasenyes()
        {
            //Validar pswAdminitrador...
            if (String.IsNullOrEmpty(txtPswAdministrador.Text) == true)
            {
                DialogResult result = MessageBox.Show("CONTRASENYA ADMINISTRADOR no definida " + System.Environment.NewLine + System.Environment.NewLine +
                                                      "Es recomana informar la contrasenya. " + System.Environment.NewLine + System.Environment.NewLine +
                                                      "Està segur que vol deixar la contrasenya en blanc ?",
                                                      "Configuració", MessageBoxButtons.YesNo, MessageBoxIcon.Error, MessageBoxDefaultButton.Button2);
                if (result.ToString() == "No")
                {
                    txtPswAdministrador.Focus();
                    return false;
                }
            }
            //Validar pswUsuari...
            if (String.IsNullOrEmpty(txtPswUsuari.Text) == true)
            {
                DialogResult result = MessageBox.Show("CONTRASENYA USUARI no definida " + System.Environment.NewLine + System.Environment.NewLine +
                                                      "Es recomana informar la contrasenya. " + System.Environment.NewLine + System.Environment.NewLine +
                                                      "Està segur que vol deixar la contrasenya en blanc ?",
                                                      "Configuració", MessageBoxButtons.YesNo, MessageBoxIcon.Error, MessageBoxDefaultButton.Button2);
                if (result.ToString() == "No")
                {
                    txtPswUsuari.Focus();
                    return false;
                }
            }

            return true;
        }







    }//fi class
}//fi namespace
