﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Globalization;
using Negoci;
using Terminal.ServiceReference1;
using NegociEntitats;

namespace Terminal
{
    public partial class frm5Format : Form
    {
        private ServiceReference1.Service1Client clientWCF = new ServiceReference1.Service1Client(); // Instancia del servei WCF
        //private simulawcfCN clientWCF = new simulawcfCN(); // simula WCF

        private formatsEntity formatAct = new formatsEntity();
        private string id_formatAct = "";
        private Boolean swnouregistre = false;
         
        public frm5Format(string id_format)
        {
            InitializeComponent();
            id_formatAct = id_format; 
        }

        private void frm3Format_Load(object sender, EventArgs e)
        {

            if (id_formatAct == "0")
            {
                altaPerDefecte();
                swnouregistre = true;
                txtId_format.Focus();
            }
            else
            {
                buscarFormat();
                txtId_format.ReadOnly = true;
                txtFormat.Focus();
            }

            moureCamps_a_Pantalla();

        }

        //********************************************************************************************
        private void acceptarButton_Click(object sender, EventArgs e)
        {
            //Valida que els camps estiguin Ok...
            Boolean correcte = true;
            correcte = validarCamps();
            if (!correcte)
            {
                return;
            }

            if (swnouregistre)
            {
                moureCamps();
                afegirFormat();
                this.Dispose();
            }
            else
            {
                moureCamps();
                modificarFormat();
                this.Dispose();
            }
        }

        //********************************************************************************************
        private void eliminarButton_Click(object sender, EventArgs e)
        {
            DialogResult result = MessageBox.Show("Confirmar l'eliminació", "Eliminar Format", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);

            if (result == DialogResult.OK)
            {
                eliminarFormat();
                this.Dispose();
            }
        }

        //********************************************************************************************
        private void cancelarButton_Click(object sender, EventArgs e)
        {
            this.Dispose();
        }


        //*********************************************************************************************************+
        //Validar els camps introduits...
        private Boolean validarCamps()
        {
            Boolean correcte = true;

            //Validar id
            if (String.IsNullOrEmpty(txtId_format.Text) == true)
            {
                DialogResult result = MessageBox.Show("Faltar informar ID FORMAT", "Format", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtFormat.Focus();
                return false;
            }

            if (txtId_format.Text.Length > 10)
            {
                DialogResult result = MessageBox.Show("El ID FORMAT sols pot tenir 10 caracters", "Format", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtId_format.Focus();
                return false;
            }

            //Validar descripció 
            if (String.IsNullOrEmpty(txtFormat.Text) == true)
            {
                DialogResult result = MessageBox.Show("Faltar informar FORMAT", "Format", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtFormat.Focus();
                return false;
            }

            //Validar duplicitat...
            if (swnouregistre)
            {
                if (clientWCF.existeixFormat(txtId_format.Text))
                {
                    DialogResult result = MessageBox.Show("ID FORMAT duplicat", "Format", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    txtId_format.Focus();
                    return false;
                }
            }


            //Retorn
            return correcte;
        }

        //*********************************************************************************************************+
        //Mou els camps a la pantalla ...
        private void moureCamps_a_Pantalla()
        {
            //FALTA   if (sociAct.id_soci == 0) txtId_materia.Text = "*** nou ***";
            txtId_format.Text = formatAct.id_format;
            txtFormat.Text = formatAct.format;
        }


        //*********************************************************************************************************+
        //Mou els camps desde pantalla ...
        private void moureCamps()
        {
            formatAct.id_format = txtId_format.Text;
            formatAct.format = txtFormat.Text;
        }

        //*********************************************************************************************************+
        //Buscar un registre a la BD...
        private void buscarFormat()
        {
            formatAct = clientWCF.buscarFormat(id_formatAct); 

        }


        
        //*********************************************************************************************************+
        //Afegir nou registre a la BD...
        private void afegirFormat()
        {
            clientWCF.afegirFormat(formatAct);
        }

        //*********************************************************************************************************+
        //Modificar registre de la BD...
        private void modificarFormat()
        {
            clientWCF.modificarFormat(formatAct);
        }

        //*********************************************************************************************************+
        //Eliminar registre de la BD...
        private void eliminarFormat()
        {
            clientWCF.eliminarFormat(id_formatAct);
        }




        //*********************************************************************************************************+
        //Valors per defecte al donar d'alta
        private void altaPerDefecte()
        {
            lblnou.Visible = true;
        }


        //*********************************************************************************************************+
        //Validar numero
        private Boolean isNumeric(string numero)
        {
            int number = 0;
            if (int.TryParse(numero.Trim(), out number)) return true;
            return false;
        }




    }//fi class
}//fi namespace
