﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Globalization;
using Negoci;
using Terminal.ServiceReference1;
using NegociEntitats;

namespace Terminal
{
    public partial class frm5Idioma : Form
    {
        private ServiceReference1.Service1Client clientWCF = new ServiceReference1.Service1Client(); // Instancia del servei WCF
        //private simulawcfCN clientWCF = new simulawcfCN(); // simula WCF

        private idiomesEntity idiomaAct = new idiomesEntity();
        private string id_idiomaAct = "";
        private Boolean swnouregistre = false;
         
        public frm5Idioma(string id_idioma)
        {
            InitializeComponent();
            id_idiomaAct = id_idioma; 
        }

        private void frm3Format_Load(object sender, EventArgs e)
        {

            if (id_idiomaAct == "0")
            {
                altaPerDefecte();
                swnouregistre = true;
                txtId_idioma.Focus();
            }
            else
            {
                buscarIdioma();
                txtId_idioma.ReadOnly = true;
                txtIdioma.Focus();
            }

            moureCamps_a_Pantalla();

        }

        //********************************************************************************************
        private void acceptarButton_Click(object sender, EventArgs e)
        {
            //Valida que els camps estiguin Ok...
            Boolean correcte = true;
            correcte = validarCamps();
            if (!correcte)
            {
                return;
            }

            if (swnouregistre)
            {
                moureCamps();
                afegirIdioma();
                this.Dispose();
            }
            else
            {
                moureCamps();
                modificarIdioma();
                this.Dispose();
            }
        }

        //********************************************************************************************
        private void eliminarButton_Click(object sender, EventArgs e)
        {
            DialogResult result = MessageBox.Show("Confirmar l'eliminació", "Eliminar Idioma", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);

            if (result == DialogResult.OK)
            {
                eliminarIdioma();
                this.Dispose();
            }
        }

        //********************************************************************************************
        private void cancelarButton_Click(object sender, EventArgs e)
        {
            this.Dispose();
        }


        //*********************************************************************************************************+
        //Validar els camps introduits...
        private Boolean validarCamps()
        {
            Boolean correcte = true;

            //Validar id
            if (String.IsNullOrEmpty(txtId_idioma.Text) == true)
            {
                DialogResult result = MessageBox.Show("Faltar informar ID IDIOMA", "Idioma", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtId_idioma.Focus();
                return false;
            }

            if (txtId_idioma.Text.Length > 3)
            {
                DialogResult result = MessageBox.Show("El ID IDIOMA sols pot tenir 3 caracters", "Idioma", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtId_idioma.Focus();
                return false;
            }

            //Validar descripció
            if (String.IsNullOrEmpty(txtIdioma.Text) == true)
            {
                DialogResult result = MessageBox.Show("Faltar informar IDIOMA", "Idioma", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtIdioma.Focus();
                return false;
            }

            //Validar duplicitat...
            if (swnouregistre)
            {
                if (clientWCF.existeixIdioma(txtId_idioma.Text))
                {
                    DialogResult result = MessageBox.Show("ID IDIOMA duplicat", "Idioma", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    txtId_idioma.Focus();
                    return false;
                }
            }


            //Retorn
            return correcte;
        }

        //*********************************************************************************************************+
        //Mou els camps a la pantalla ...
        private void moureCamps_a_Pantalla()
        {
            txtId_idioma.Text = idiomaAct.id_idioma;
            txtIdioma.Text = idiomaAct.idioma;
        }


        //*********************************************************************************************************+
        //Mou els camps desde pantalla ...
        private void moureCamps()
        {
            idiomaAct.id_idioma = txtId_idioma.Text;
            idiomaAct.idioma = txtIdioma.Text;
        }

        //*********************************************************************************************************+
        //Buscar un registre a la BD...
        private void buscarIdioma()
        {
            idiomaAct = clientWCF.buscarIdioma(id_idiomaAct); 

        }

        
        //*********************************************************************************************************+
        //Afegir nou registre a la BD...
        private void afegirIdioma()
        {
            clientWCF.afegirIdioma(idiomaAct);
        }

        //*********************************************************************************************************+
        //Modificar registre de la BD...
        private void modificarIdioma()
        {
            clientWCF.modificarIdioma(idiomaAct);
        }

        //*********************************************************************************************************+
        //Eliminar registre de la BD...
        private void eliminarIdioma()
        {
            clientWCF.eliminarIdioma(id_idiomaAct);
        }




        //*********************************************************************************************************+
        //Valors per defecte al donar d'alta
        private void altaPerDefecte()
        {
            lblnou.Visible = true;
        }


        //*********************************************************************************************************+
        //Validar numero
        private Boolean isNumeric(string numero)
        {
            int number = 0;
            if (int.TryParse(numero.Trim(), out number)) return true;
            return false;
        }




    }//fi class
}//fi namespace
