﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Negoci;
using Terminal.ServiceReference1;
using NegociEntitats;


namespace Terminal
{
    public partial class frm5IdiomaVer : Form
    {
        private ServiceReference1.Service1Client clientWCF = new ServiceReference1.Service1Client(); // Instancia del servei WCF
        //private simulawcfCN clientWCF = new simulawcfCN(); // simula WCF
        
        private List<idiomesEntity> ListRegs;

        public frm5IdiomaVer()
        {
            InitializeComponent();

        }

        private void btnSortir_Click(object sender, EventArgs e)
        {
            gblParametres parametres = gblParametres.Instance();
            parametres.frm5IdiomaVer = 0;

            this.Dispose();
        }

        //Cargar formulari...
        private void frm2IdiomaVer_Load(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Maximized;

            //carregar el grid...
            carregarGrid();
        }


        //****************************************************************************************
        private void btnModificar_Click(object sender, EventArgs e)
        {
            //Comprovem si hi ha quelcom a la llista...
            if (gridRegistres.RowCount == 0)
            {
                return; 
            }
            //recuperem la linea sel.lecionada

            DataGridViewRow row = this.gridRegistres.CurrentRow;
            string id_idioma = "";
            id_idioma = row.Cells[0].Value.ToString();
            //modificar ....
            frm5Idioma f = new frm5Idioma(id_idioma);
            f.WindowState = FormWindowState.Normal;
            f.ShowDialog();

            //Refresca el grid, per si hi han canvis...
            carregarGrid();

        }


        //****************************************************************************************
        private void btnNouRegistre_Click(object sender, EventArgs e)
        {
            //Nou document ....
            frm5Idioma f = new frm5Idioma("0");
            f.WindowState = FormWindowState.Normal;
            f.ShowDialog();

            //Refresca el grid, per si hi han canvis...
            carregarGrid();
        }



        //****************************************************************************************
        // Carrega la llista al datagridView .....
        private void carregarGrid()
        {
            Boolean llistaBuida = false;

            //Recupera la llista de registres..
            ListRegs = clientWCF.llistarIdiomes().ToList();

            //Passem la Llista a una Table temporal
            gridRegistres.DataSource = null;
            gridRegistres.Rows.Clear();
            gridRegistres.ClearSelection();


            if (ListRegs == null) llistaBuida = true;
            if (ListRegs.Count == 0) llistaBuida = true;
            if (llistaBuida)
            {
                DialogResult nada = MessageBox.Show("No hi han idiomes", "Idiomes", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return;
            }

            //Passar la llista de registres obtinguda al grid...
            for (int i = 0; i < ListRegs.Count(); i++)
            {
                gridRegistres.Rows.Add();
                gridRegistres.Rows[i].Cells[0].Value = ListRegs.ElementAt(i).id_idioma;
                gridRegistres.Rows[i].Cells[1].Value = ListRegs.ElementAt(i).idioma;
            }

            gridRegistres.Refresh();

        }

        //****************************************************************************************
        private void gridRegistres_DoubleClick(object sender, EventArgs e)
        {
            btnModificar_Click(sender, e);
        }

        //****************************************************************************************
        private void frm5IdiomaVer_FormClosing(object sender, FormClosingEventArgs e)
        {
            gblParametres parametres = gblParametres.Instance();
            parametres.frm5IdiomaVer = 0;
        }



    } //fi classe
} //fi namepace
