﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Globalization;
using Negoci;
using Terminal.ServiceReference1;
using NegociEntitats;

namespace Terminal
{
    public partial class frm5Materia : Form
    {
        private ServiceReference1.Service1Client clientWCF = new ServiceReference1.Service1Client(); // Instancia del servei WCF
        //private simulawcfCN clientWCF = new simulawcfCN(); // simula WCF

        private materiesEntity materiaAct = new materiesEntity();
        private string id_materiaAct = "";
        private Boolean swnouregistre = false;
         
        public frm5Materia(string id_materia)
        {
            InitializeComponent();
            id_materiaAct = id_materia; 
        }

        private void frm5Materia_Load(object sender, EventArgs e)
        {

            if (id_materiaAct == "00000")
            {
                altaPerDefecte();
                swnouregistre = true;
                txtId_materia.Focus();
            }
            else
            {
                buscarMateria();
                txtId_materia.ReadOnly = true;
                txtMateria.Focus();
            }

            moureCamps_a_Pantalla();

        }

        private void acceptarButton_Click(object sender, EventArgs e)
        {
            //Valida que els camps estiguin Ok...
            Boolean correcte = true;
            correcte = validarCamps();
            if (!correcte)
            {
                return;
            }

            if (swnouregistre)
            {
                moureCamps();
                afegirMateria();
                this.Dispose();
            }
            else
            {
                moureCamps();
                modificarMateria();
                this.Dispose();
            }
        }

        //********************************************************************************************
        private void eliminarButton_Click(object sender, EventArgs e)
        {
            DialogResult result = MessageBox.Show("Confirmar l'eliminació", "Eliminar Matèria", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);

            if (result == DialogResult.OK)
            {
                eliminarMateria();
                this.Dispose();
            }
        }

        private void cancelarButton_Click(object sender, EventArgs e)
        {
            this.Dispose();
        }


        //*********************************************************************************************************+
        //Validar els camps introduits...
        private Boolean validarCamps()
        {
            Boolean correcte = true;

            //Validar id
            if (String.IsNullOrEmpty(txtId_materia.Text) == true)
            {
                DialogResult result = MessageBox.Show("Faltar informar ID MATÈRIA", "Matèria", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtId_materia.Focus();
                return false;
            }

            if (txtId_materia.Text.Length > 10)
            {
                DialogResult result = MessageBox.Show("El ID MATÈRIA sols pot tenir 10 caracters", "Matèria", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtId_materia.Focus();
                return false;
            }

            //Validar descripció
            if (String.IsNullOrEmpty(txtMateria.Text) == true)
            {
                DialogResult result = MessageBox.Show("Faltar informar MATÈRIA", "Matèria", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtMateria.Focus();
                return false;
            }

            //Validar duplicitat...
            if (swnouregistre)
            {
                if (clientWCF.existeixMateria(txtId_materia.Text))
                {
                    DialogResult result = MessageBox.Show("ID MATERIA duplicat", "Matèria", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    txtId_materia.Focus();
                    return false;
                }
            }


            //Retorn
            return correcte;
        }

        //*********************************************************************************************************+
        //Mou els camps a la pantalla ...
        private void moureCamps_a_Pantalla()
        {
            //FALTA   if (sociAct.id_soci == 0) txtId_materia.Text = "*** nou ***";
            txtId_materia.Text = materiaAct.id_materia;
            txtMateria.Text = materiaAct.materia;
        }


        //*********************************************************************************************************+
        //Mou els camps desde pantalla ...
        private void moureCamps()
        {
            materiaAct.id_materia = txtId_materia.Text;
            materiaAct.materia = txtMateria.Text;
        }

        //*********************************************************************************************************+
        //Buscar un registre a la BD...
        private void buscarMateria()
        {
            materiaAct = clientWCF.buscarMateria(id_materiaAct); 

        }


        
        //*********************************************************************************************************+
        //Afegir nou registre a la BD...
        private void afegirMateria()
        {
            clientWCF.afegirMateria(materiaAct);
        }

        //*********************************************************************************************************+
        //Modificar registre de la BD...
        private void modificarMateria()
        {
            clientWCF.modificarMateria(materiaAct);
        }

        //*********************************************************************************************************+
        //Eliminar registre de la BD...
        private void eliminarMateria()
        {
            clientWCF.eliminarMateria(id_materiaAct);
        }




        //*********************************************************************************************************+
        //Valors per defecte al donar d'alta
        private void altaPerDefecte()
        {
            lblnou.Visible = true;
        }


        //*********************************************************************************************************+
        //Validar numero
        private Boolean isNumeric(string numero)
        {
            int number = 0;
            if (int.TryParse(numero.Trim(), out number)) return true;
            return false;
        }




    }//fi class
}//fi namespace
