﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Globalization;
using Negoci;
using Terminal.ServiceReference1;
using NegociEntitats;

namespace Terminal
{
    public partial class frm5Tema : Form
    {
        private ServiceReference1.Service1Client clientWCF = new ServiceReference1.Service1Client(); // Instancia del servei WCF
        //private simulawcfCN clientWCF = new simulawcfCN(); // simula WCF

        private temesEntity temaAct = new temesEntity();
        private string id_temaAct = "";
        private Boolean swnouregistre = false;

        //********************************************************************************************
        public frm5Tema(string id_tema)
        {
            InitializeComponent();
            id_temaAct = id_tema; 
        }

        //********************************************************************************************
        private void frm5Tema_Load(object sender, EventArgs e)
        {

            if (id_temaAct == "0")
            {
                altaPerDefecte();
                swnouregistre = true;
                txtId_tema.Focus();
            }
            else
            {
                buscarTema();
                txtId_tema.ReadOnly = true;
            }

            moureCamps_a_Pantalla();

        }

        //********************************************************************************************
        private void acceptarButton_Click(object sender, EventArgs e)
        {
            //Valida que els camps estiguin Ok...
            Boolean correcte = true;
            correcte = validarCamps();
            if (!correcte)
            {
                return;
            }

            if (swnouregistre)
            {
                moureCamps();
                afegirTema();
                this.Dispose();
            }
            else
            {
                moureCamps();
                modificarTema();
                this.Dispose();
            }
        }

        //********************************************************************************************
        private void eliminarButton_Click(object sender, EventArgs e)
        {
            DialogResult result = MessageBox.Show("Confirmar l'eliminació", "Eliminar Tema", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);

            if (result == DialogResult.OK)
            {
                eliminarTema();
                this.Dispose();
            }
        }

        private void cancelarButton_Click(object sender, EventArgs e)
        {
            this.Dispose();
        }


        //*********************************************************************************************************+
        //Validar els camps introduits...
        private Boolean validarCamps()
        {
            Boolean correcte = true;

            //Validar id
            if (String.IsNullOrEmpty(txtId_tema.Text) == true)
            {
                DialogResult result = MessageBox.Show("Faltar informar ID TEMA", "Tema", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtId_tema.Focus();
                return false;
            }

            if (txtId_tema.Text.Length > 10)
            {
                DialogResult result = MessageBox.Show("El ID TEMA sols pot tenir 10 caracters", "Tema", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtId_tema.Focus();
                return false;
            }

            //Validar descripcio 
            if (String.IsNullOrEmpty(txtTema.Text) == true)
            {
                DialogResult result = MessageBox.Show("Faltar informar TEMA", "Tema", MessageBoxButtons.OK, MessageBoxIcon.Error);
                txtTema.Focus();
                return false;
            }

            //Validar duplicitat...
            if (swnouregistre)
            {
                if (clientWCF.existeixTema(txtId_tema.Text))
                {
                    DialogResult result = MessageBox.Show("ID TEMA duplicat", "Tema", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    txtId_tema.Focus();
                    return false;
                }
            }



            //Retorn
            return correcte;
        }

        //*********************************************************************************************************+
        //Mou els camps a la pantalla ...
        private void moureCamps_a_Pantalla()
        {
            txtId_tema.Text = temaAct.id_tema;
            txtTema.Text = temaAct.tema;
        }


        //*********************************************************************************************************+
        //Mou els camps desde pantalla ...
        private void moureCamps()
        {
            temaAct.id_tema = txtId_tema.Text;
            temaAct.tema = txtTema.Text;
        }

        //*********************************************************************************************************+
        //Buscar un registre a la BD...
        private void buscarTema()
        {
            temaAct = clientWCF.buscarTema(id_temaAct); 

        }


        
        //*********************************************************************************************************+
        //Afegir nou registre a la BD...
        private void afegirTema()
        {
            clientWCF.afegirTema(temaAct);
        }

        //*********************************************************************************************************+
        //Modificar registre de la BD...
        private void modificarTema()
        {
            clientWCF.modificarTema(temaAct);
        }

        //*********************************************************************************************************+
        //Eliminar registre de la BD...
        private void eliminarTema()
        {
            clientWCF.eliminarTema(id_temaAct);
        }




        //*********************************************************************************************************+
        //Valors per defecte al donar d'alta
        private void altaPerDefecte()
        {
            lblnou.Visible = true;
        }


        //*********************************************************************************************************+
        //Validar numero
        private Boolean isNumeric(string numero)
        {
            int number = 0;
            if (int.TryParse(numero.Trim(), out number)) return true;
            return false;
        }




    }//fi class
}//fi namespace
