﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Data;
using System.Data.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using AccesDB;
using Negoci;
using NegociEntitats;

namespace WcfService
{
    [ServiceContract]
    public interface IService1
    {

        //************************************************************************************
        //******* DOCUMENTS ******************************************************************
        [OperationContract]
        Boolean existeixDocument(int id_document);

        [OperationContract]
        documentsEntity buscarDocument(int id_document);
        
        [OperationContract]
        void afegirDocument(documentsEntity documentAct);

        [OperationContract]
        void modificarDocument(documentsEntity documentAct);

        [OperationContract]
        void eliminarDocument(int id_document);

        [OperationContract]
        List<documentsEntity> llistarDocuments(int tipoConsulta, string valorBuscat);

        [OperationContract]
        void canviarUnitatsDocument(int id_document, int unitats);


        //************************************************************************************
        //******* SOCIS **********************************************************************
        [OperationContract]
        Boolean existeixSoci(int id_soci);

        [OperationContract]
        socisEntity buscarSoci(int id_soci);

        [OperationContract]
        void afegirSoci(socisEntity sociAct);

        [OperationContract]
        void modificarSoci(socisEntity sociAct);

        [OperationContract]
        void modificarSociWeb(int id_soci, string telefon, string email);

        [OperationContract]
        void eliminarSoci(int id_soci);

        [OperationContract]
        List<socisEntity> llistarSocis(int tipoConsulta, string valorBuscat);

        [OperationContract]
        int validarLoginSoci(string usuari, string contrasenya);

        [OperationContract]
        Boolean existeixEmailSoci(int id_soci, string email);

        [OperationContract]
        Boolean existeixDniSoci(int id_soci, string dni);

        [OperationContract]
        void canviarContrasenyaSociWeb(int id_soci, string contrasenya);

        //************************************************************************************
        //******* PRESTECS *******************************************************************
        [OperationContract]
        prestecsEntity buscarPrestec(int id_prestec);

        [OperationContract]
        prestecsEntity buscarPrestecIdDocument(int id_document);

        [OperationContract]
        void afegirPrestec(prestecsEntity prestecAct);

        [OperationContract]
        void modificarPrestec(prestecsEntity prestecAct);

        [OperationContract]
        void eliminarPrestec(int id_prestec);

        [OperationContract]
        string calcularRenovacioPrestec(string dataFiPrestec, int diesPrestec);

        [OperationContract]
        void renovacioPrestecWeb(prestecsEntity prestecAct);

        [OperationContract]
        List<prestecsEntity> llistarPrestecsIdSoci(int id_soci);

        [OperationContract]
        List<prestecsEntity> llistarPrestecs(int tipoConsulta, string valorBuscat);

        [OperationContract]
        int buscarPrestecsActiusIdSoci(int id_soci);

        
        //************************************************************************************
        //******* FORMATS ********************************************************************
        [OperationContract]
        Boolean existeixFormat(string id_format);
        
        [OperationContract]
        formatsEntity buscarFormat(string id_format);

        [OperationContract]
        void afegirFormat(formatsEntity formatAct);

        [OperationContract]
        void modificarFormat(formatsEntity formatAct);

        [OperationContract]
        void eliminarFormat(string id_format);

        [OperationContract]
        List<formatsEntity> llistarFormats();

        //************************************************************************************
        //******* MATERIES *******************************************************************
        [OperationContract]
        Boolean existeixMateria(string id_materia);
        
        [OperationContract]
        materiesEntity buscarMateria(string id_materia);

        [OperationContract]
        void afegirMateria(materiesEntity materiaAct);

        [OperationContract]
        void modificarMateria(materiesEntity materiaAct);

        [OperationContract]
        void eliminarMateria(string id_materia);

        [OperationContract]
        List<materiesEntity> llistarMateries();

        //************************************************************************************
        //******* TEMES **********************************************************************
        [OperationContract]
        Boolean existeixTema(string id_tema);
        
        [OperationContract]
        temesEntity buscarTema(string id_tema);

        [OperationContract]
        void afegirTema(temesEntity temaAct);

        [OperationContract]
        void modificarTema(temesEntity temaAct);

        [OperationContract]
        void eliminarTema(string id_tema);
        
        [OperationContract]
        List<temesEntity> llistarTemes();

        //************************************************************************************
        //******* IDIOMES ********************************************************************
        [OperationContract]
        Boolean existeixIdioma(string id_idioma);
        
        [OperationContract]
        idiomesEntity buscarIdioma(string id_idioma);

        [OperationContract]
        void afegirIdioma(idiomesEntity idiomaAct);

        [OperationContract]
        void modificarIdioma(idiomesEntity idiomaAct);

        [OperationContract]
        void eliminarIdioma(string id_idioma);

        [OperationContract]
        List<idiomesEntity> llistarIdiomes();


        //************************************************************************************
        //******* TIPUS SOCIS ****************************************************************
        [OperationContract]
        Boolean existeixTipusSoci(int id_tipusSoci);
        
        [OperationContract]
        tipusSocisEntity buscarTipusSoci(int id_tipusSoci);

        [OperationContract]
        void afegirTipusSoci(tipusSocisEntity tipusSociAct);

        [OperationContract]
        void modificarTipusSoci(tipusSocisEntity tipusSociAct);

        [OperationContract]
        void eliminarTipusSoci(int id_tipusSoci);

        [OperationContract]
        List<tipusSocisEntity> llistarTipusSocis();


        //************************************************************************************
        //******* CONFIGURACIO ***************************************************************
        [OperationContract]
        configuracioEntity buscarConfiguracio();

        [OperationContract]
        void modificarConfiguracio(configuracioEntity configuracioAc);

        [OperationContract]
        string validarLoginConfiguracio(string usuari, string contrasenya);
    }
}
