﻿using System;
using System.Data;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Website.ServiceReference1;

namespace Website
{
    public partial class Cataleg : System.Web.UI.Page
    {
        ServiceReference1.Service1Client clientWCF = new ServiceReference1.Service1Client(); // Instancia del servei WCF
        private List<documentsEntity> ListDocs;
        private int pageIndexAnt = 0;


        //****************************************************************************************
        protected void Page_Load(object sender, EventArgs e)
        {
            string paginaAnt = "";
            paginaAnt = (string)Session["url"];
            pageIndexAnt = (int)Session["pageIndex"];

            txtCercar.Focus();
            if (!Page.IsPostBack)
            {
                //Vinc de veure la fitxa d'un document, torno a mostrar la llista
                if (paginaAnt == "Document")
                {
                    txtCercar.Text = (string)Session["txtCercar"];
                    cercarDadesGrid();
                    carregarGrid();
                }
            }
            
            //pagina actual
            Session["url"] = "Cataleg";

        }

        //****************************************************************************************
        //  Cercar document
        protected void btnCercar_Click(object sender, EventArgs e)
        {
            Session["txtCercar"] = "";
            cercarDadesGrid();
            carregarGrid();
        }


        //****************************************************************************************
        // Buscar dades per ficar al Datagrid...
        private void cercarDadesGrid()
        {

            //Botó Cercar...
            //Cercar per titol, autor, tema, isbn, signatura
            if (String.IsNullOrEmpty(txtCercar.Text) == false)
            {
               //El index del combo+3 indica el tipo de busqueda per la llista de llistDocuments
               // 1=Especial per buscar tot si l'entrada a buscar és "*"
               // 3=titol, 4=autor, 5=isbn, 6=signatura
               int selectedIndex = 0;
               selectedIndex = cmbCercar.SelectedIndex + 3;
               if (txtCercar.Text == "*")
               {
                   ListDocs = clientWCF.llistarDocuments(1, txtCercar.Text).ToList();
               }
               else
               {
                   ListDocs = clientWCF.llistarDocuments(selectedIndex, txtCercar.Text).ToList();
               }
            }

        }


        //****************************************************************************************
        // Carrega la llista al datagridView .....
        private void carregarGrid()
        {
            Boolean llistaBuida = false;

            //Esborrar grid...
            gridDocuments.DataSource = null;
            gridDocuments.DataBind();
            
            
            if (ListDocs == null) llistaBuida = true;
            if (!llistaBuida)
            {
                if (ListDocs.Count == 0) llistaBuida = true;
            }
            if (llistaBuida)
            {
                gridDocuments.EmptyDataText = "No hi han documents que compleixin les condicions de cerca";
                return;
            }


            Session["txtCercar"] = txtCercar.Text;
            Session["pageIndex"] = 0;

            //Passar la llista de documents obtinguda al grid...
            //Es crea una table de suport...
            DataTable taula = new DataTable();
            taula.Columns.Add("Id", typeof(string));
            taula.Columns.Add("Títol", typeof(string));
            taula.Columns.Add("Autor", typeof(string));
            taula.Columns.Add("Format", typeof(string));
            taula.Columns.Add("Disponible", typeof(string));

            //Carreguem la llista a la taula
            for (int i = 0; i < ListDocs.Count(); i++)
            {
                DataRow dr = taula.NewRow();
                dr[0] = ListDocs.ElementAt(i).id_document.ToString();
                dr[1] = ListDocs.ElementAt(i).titol.ToString();
                dr[2] = ListDocs.ElementAt(i).autor.ToString();
                dr[3] = ListDocs.ElementAt(i).id_format.ToString();
                dr[4] = "si";
                if (ListDocs.ElementAt(i).numUnitatsDisponibles == 0)
                {
                    dr[4] = "--";
                }
                taula.Rows.Add(dr);
            }
            
            //carreguem la taula al datagrid
            gridDocuments.DataSource = taula;
            if (pageIndexAnt != 0)
            {
                gridDocuments.PageIndex = pageIndexAnt;
            }
            gridDocuments.DataBind();

        }

        //****************************************************************************************
        protected void gridDocuments_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (gridDocuments.Rows.Count>0) {
            //e.Row.Cells[0].Width = 150;
            //e.Row.Cells[1].Width = 150;
            //e.Row.Cells[2].Width = 70;
            //e.Row.Cells[3].Width = 70;

            }
        }

        protected void gridDocuments_RowCommand(object sender, GridViewCommandEventArgs e)
        {

            //Response.Write("ha pulsado=" + gridDocuments.SelectedIndex.ToString());

        }

        //***************************************************************************************
        protected void gridDocuments_SelectedIndexChanged(object sender, EventArgs e)
        {
            //recuperem les dades de la fila seleccionada
            int id_document = int.Parse(gridDocuments.SelectedRow.Cells[1].Text);
            // Response.Write("ha pulsado=" + gridDocuments.SelectedIndex.ToString() + "  id=" +id_document.ToString());
            Session["id_document"] = id_document.ToString();
            Response.Redirect("~/Document.aspx"); 
        }

        //****************************************************************************************
        protected void gridDocuments_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
            cercarDadesGrid();
            carregarGrid();
            gridDocuments.PageIndex = e.NewPageIndex;
            gridDocuments.DataBind();
            Session["pageIndex"] = e.NewPageIndex;
        }



    }//fi classe
}//fi namespace