﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Website.ServiceReference1;

namespace Website
{
    public partial class Document : System.Web.UI.Page
    {
        ServiceReference1.Service1Client clientWCF = new ServiceReference1.Service1Client(); // Instancia del servei WCF
        private documentsEntity documentAct;
        private idiomesEntity idiomaAct;
        private int id_documentAct=0;
        
        
        protected void Page_Load(object sender, EventArgs e)
        {
            string caracteristiques = "";
            string id_documentActx = "";
            int number = 0;
            string coma;

            Session["url"] = "Document";

            //Buscar document
            id_documentActx = (string)Session["id_document"];
            if (Int32.TryParse(id_documentActx, out number))
            {
                id_documentAct = number;
            }
            documentAct = clientWCF.buscarDocument(id_documentAct);
            idiomaAct = clientWCF.buscarIdioma(documentAct.idioma); 

            if (documentAct != null)
            {
                lblId.Text = documentAct.id_document.ToString();
                lblTitol.Text = documentAct.titol;
                lblAutor.Text = documentAct.autor;
                lblFormat.Text = documentAct.id_format;
                lblIsbn.Text = documentAct.isbn;
                lblTema.Text = documentAct.tema;
                lblMateria.Text = documentAct.materia;
                lblEditorial.Text = documentAct.publicacioEditorial;
                coma = "";
                if (documentAct.publicacioLloc != "") coma = ", ";
                lblPublicacio.Text = documentAct.publicacioLloc + coma + documentAct.publicacioAny.ToString();
                lblIdioma.Text = idiomaAct.idioma;
                coma = "";
                if (documentAct.numPagines != 0)
                {
                    caracteristiques = "pàgines: " + documentAct.numPagines.ToString();
                }
                if (documentAct.duradaMinuts!=0)
                {
                    caracteristiques = caracteristiques + " durada (min): " + documentAct.duradaMinuts.ToString();
                }
                if (documentAct.color !="")
                {
                    if (caracteristiques != "") coma = ", ";
                    caracteristiques = caracteristiques + coma + "color: " + documentAct.color;
                }

                lblCaracteristiques.Text = caracteristiques;
                lblDisponible.Text = "si";
                if (documentAct.numUnitatsDisponibles==0)
                {
                    lblDisponible.Text = "no";
                }
                if (documentAct.actiu==false)
                {
                    lblDisponible.Text = "no";
                }

                //Foto
                imageDoc.ImageUrl = "~/imagesDoc/sinfoto.jpg";
                if (String.IsNullOrEmpty(documentAct.imatge) == false)
                {
                    imageDoc.ImageUrl = "~/imagesDoc/" + documentAct.imatge;
                }


            }

        }

        //****************************************************************
        protected void Tornar_Click(object sender, EventArgs e)
        {
            Response.Redirect("~/Cataleg.aspx"); 
        }
    }
}