﻿using System;
using System.Data;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Website.ServiceReference1;

namespace Website
{
    public partial class EspaiPersonal : System.Web.UI.Page
    {
        ServiceReference1.Service1Client clientWCF = new ServiceReference1.Service1Client(); // Instancia del servei WCF
        private socisEntity sociAct;
        private List<prestecsEntity> ListPrestecs;
        private int pageIndexAnt = 0;
        
        
        protected void Page_Load(object sender, EventArgs e)
        {
            string paginaAnt = "";
            paginaAnt = (string)Session["url"];
            sociAct = (socisEntity)Session["Usuari"];

            if (sociAct != null)
            {
                lblidSoci.Text = "Núm. soci: " + sociAct.id_soci.ToString();
                lblNom.Text = sociAct.cognoms + ", " + sociAct.nom;
                lblAdreca.Text = sociAct.adreca;
                lblPoblacio.Text = sociAct.cp + " " + sociAct.poblacio;
                lblTelefon.Text = "Tel. " + sociAct.telefon;
            }

            if (!Page.IsPostBack)
            {
                //Vinc de Renovacio, torno a mostrar el historial
                if (paginaAnt == "Renovacio")
                {
                    pageIndexAnt = (int)Session["pageIndexHistorial"];
                    cercarDadesGrid();
                    carregarGrid();
                }
            }


            //pagina actual
            Session["url"] = "EspaiPersonal";

        }

        // ********************************************************************************************
        protected void historial_Click(object sender, EventArgs e)
        {
            //Buscar els prestecs del soci...
            if (sociAct != null)
            {
                cercarDadesGrid();
                carregarGrid();
            }
        }

        // ********************************************************************************************
        // proves
        protected void renovar_Click(object sender, EventArgs e)
        {
            Session["id_prestec"] = "5";
            Response.Redirect("~/Renovacio.aspx");
        }


        //****************************************************************************************
        // Buscar dades per ficar al Datagrid...
        private void cercarDadesGrid()
        {
            ListPrestecs = clientWCF.llistarPrestecsIdSoci(sociAct.id_soci).ToList(); 
        }


        //****************************************************************************************
        // Carrega la llista al datagridView .....
        private void carregarGrid()
        {
            Boolean llistaBuida = false;
            string dataFi = "";
            string dataRetorn = "";
            string estat = "";
            Boolean retornat=false;

            //Esborrar grid...
            gridPrestecs.DataSource = null;
            gridPrestecs.DataBind();

            if (ListPrestecs == null) llistaBuida = true;
            if (ListPrestecs.Count == 0) llistaBuida = true;

            if (llistaBuida)
            {
                gridPrestecs.EmptyDataText = "No s'ha realitzar cap préstec";
                return;
            }

            Session["pageIndexHistorial"] = 0;

            //Passar la llista de documents obtinguda al grid...
            //Es crea una table de suport...
            DataTable taula = new DataTable();
            //taula.Columns.Add("id_prestec", typeof(string));
            //taula.Columns.Add("Títol", typeof(string));
            //taula.Columns.Add("Autor/Director", typeof(string));
            //taula.Columns.Add("Format", typeof(string));
            //taula.Columns.Add("data préstec", typeof(string));
            //taula.Columns.Add("data devolució", typeof(string));
            //taula.Columns.Add("estat", typeof(string));
            taula.Columns.Add("id_prestec", typeof(string));
            taula.Columns.Add("titol", typeof(string));
            taula.Columns.Add("autor", typeof(string));
            taula.Columns.Add("format", typeof(string));
            taula.Columns.Add("dataInici", typeof(string));
            taula.Columns.Add("dataRetorn", typeof(string));
            taula.Columns.Add("estat", typeof(string));

            //Carreguem la llista a la taula
            for (int i = 0; i < ListPrestecs.Count(); i++)
            {
                DataRow dr = taula.NewRow();
                dataFi = ListPrestecs.ElementAt(i).dataFiPrestec.ToString("dd/MM/yyyy");
                dataRetorn = ListPrestecs.ElementAt(i).dataRetornPrestec.ToString("dd/MM/yyyy");
                retornat = ListPrestecs.ElementAt(i).retornat;
                estat = "retornat";
                if (!retornat) 
                {
                    estat="actiu, a retornar fins el " + dataFi;
                    dataRetorn="--";
                }

                //s'afegix el id_prestec al inici
                dr[0] = ListPrestecs.ElementAt(i).id_prestec.ToString();
                dr[1] = ListPrestecs.ElementAt(i).titol.ToString();
                dr[2] = ListPrestecs.ElementAt(i).autor.ToString();
                dr[3] = ListPrestecs.ElementAt(i).id_format.ToString();
                dr[4] = ListPrestecs.ElementAt(i).dataIniciPrestec.ToString("dd/MM/yyyy");
                dr[5] = dataRetorn;
                dr[6] = estat;
                if (retornat == false) dr[5] = "";

                taula.Rows.Add(dr);
            }

            //carreguem la taula al datagrid
            lblHistorial.Text = "Historial de préstecs";
            gridPrestecs.DataSource = taula;
            if (pageIndexAnt != 0)
            {
                gridPrestecs.PageIndex = pageIndexAnt;
            }

            gridPrestecs.DataBind();
        }

        //****************************************************************************************
        protected void modificar_Click(object sender, EventArgs e)
        {
            Response.Redirect("~/ModificarDades.aspx"); 
        }

        //****************************************************************************************
        protected void xxxxxxxxcontrasenya_Click(object sender, EventArgs e)
        {
            Response.Redirect("/Account/ChangePassword.aspx");
        }

        //****************************************************************************************
        protected void contrasenya_Click(object sender, EventArgs e)
        {
            Response.Redirect("~/ModificarContrasenya.aspx"); 

        }



        //****************************************************************************************
        protected void gridPrestecs_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
            cercarDadesGrid();
            carregarGrid();
            gridPrestecs.PageIndex = e.NewPageIndex;
            gridPrestecs.DataBind();
            Session["pageIndexHistorial"] = e.NewPageIndex;
        }

        //****************************************************************************************
        protected void gridPrestecs_SelectedIndexChanged(object sender, EventArgs e)
        {
            //recuperem les dades de la fila seleccionada
            GridViewRow row = gridPrestecs.SelectedRow;
            string id_prestec = gridPrestecs.DataKeys[row.RowIndex].Value.ToString();
            Session["id_prestec2"] = id_prestec.ToString();
            Session["id_prestec"] = id_prestec.ToString(); 
            Response.Redirect("~/Renovacio.aspx");

        }

    


    }//fi classe
}//fi namespace