﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Website.ServiceReference1;

namespace Website
{

    public partial class ModificarDades : System.Web.UI.Page
    {
        ServiceReference1.Service1Client clientWCF = new ServiceReference1.Service1Client(); // Instancia del servei WCF
        private socisEntity sociAct;

        protected void Page_Load(object sender, EventArgs e)
        {

            sociAct = (socisEntity)Session["Usuari"];

            //Primera vegada que es carrega la pàgina...
            if (!Page.IsPostBack)
            {
                if (sociAct != null)
                {
                    lblidSoci.Text = "Núm. soci: " + sociAct.id_soci.ToString();
                    lblNom.Text = sociAct.cognoms + ", " + sociAct.nom;
                    lblAdreca.Text = sociAct.adreca;
                    lblPoblacio.Text = sociAct.cp + " " + sociAct.poblacio;
                    txtTelefon.Text = sociAct.telefon;
                    txtEmail.Text = sociAct.email;
                }
            }
            else
            {
                  //Recarrego la pàgina, desactivo el boto acceptar
                    btnacceptar.Enabled = false;
            }
        }

        
        // ********************************************************************************************
        protected void btnacceptar_Click(object sender, EventArgs e)
        {
            Boolean swcanvi = false;
            litMissatge.Text = "";

            //comprova si existeix el email...
            if (txtEmail.Text != sociAct.email)
            {
                if (clientWCF.existeixEmailSoci(sociAct.id_soci, txtEmail.Text) == true)
                {
                    litMissatge.Text = "Email existent. No es modifiquen les dades";
                    return;
                }

                if (String.IsNullOrEmpty(txtEmail.Text) == false)
                {
                    txtEmail.Text = txtEmail.Text.Trim();
                    if (txtEmail.Text.IndexOf("@") < 1 || txtEmail.Text.IndexOf(".") < 3 || txtEmail.Text.Length < 5)
                    {
                        litMissatge.Text = "Email amb format incorrecte. No es modifiquen les dades";
                        return;
                    }
                }
            }
            
            
            //comprova si s'han fet canvis
            if (txtTelefon.Text != sociAct.telefon) swcanvi = true;
            if (txtEmail.Text != sociAct.email) swcanvi = true;

            sociAct = (socisEntity)Session["Usuari"];
            //si s'han fet canvis, actualitzar BD...
            if (swcanvi)
            {
                clientWCF.modificarSociWeb(sociAct.id_soci, txtTelefon.Text, txtEmail.Text);
                litMissatge.Text="Dades actualitzades";

                //Actualitza les dades de sessió
                sociAct = clientWCF.buscarSoci(sociAct.id_soci);
                Session["Usuari"] = sociAct;

            }

        }

        // ********************************************************************************************
        protected void Tornar_Click(object sender, EventArgs e)
        {
            Response.Redirect("~/EspaiPersonal.aspx"); 
        }

    }//fi classe
}//fi namespace