﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Website.ServiceReference1;

namespace Website
{
    public partial class Renovacio : System.Web.UI.Page
    {
        ServiceReference1.Service1Client clientWCF = new ServiceReference1.Service1Client(); // Instancia del servei WCF
        private configuracioEntity configuracioAct;
        private documentsEntity documentAct;
        private prestecsEntity prestecAct;
        private int id_prestecAct = 0;
        
        protected void Page_Load(object sender, EventArgs e)
        {
            Session["url"] = "Renovacio";
            if (Page.IsPostBack)
            {
                //Recarrego la pàgina, desactivo el boto renovar
                Renovar.Enabled = false;
            }

            buscarPrestec();
        }


        //****************************************************************
        //Buscar prestec i document
        protected void buscarPrestec()
        {
            string id_prestecActx = "";
            int number = 0;
            string dataRetorn = "";
            string estat = "";

            id_prestecActx = (string)Session["id_prestec"];
            if (Int32.TryParse(id_prestecActx, out number))
            {
                id_prestecAct = number;
            }

            configuracioAct = clientWCF.buscarConfiguracio();
            prestecAct = clientWCF.buscarPrestec(id_prestecAct);
            documentAct = clientWCF.buscarDocument(prestecAct.id_document);

            if (documentAct != null)
            {
                lblIdPrestec.Text = prestecAct.id_prestec.ToString();
                lblIdDocument.Text = documentAct.id_document.ToString();
                lblTitol.Text = documentAct.titol;
                lblAutor.Text = documentAct.autor;
                lblFormat.Text = documentAct.id_format;
                lblDataIniciPrestec.Text = prestecAct.dataIniciPrestec.ToString("dd/MM/yyyy");
                lblDataFiPrestec.Text = prestecAct.dataFiPrestec.ToString("dd/MM/yyyy");
                dataRetorn = prestecAct.dataRetornPrestec.ToString("dd/MM/yyyy");
                estat = "retornat";
                if (prestecAct.retornat==false)
                {
                    estat = "actiu, a retornar fins el " + lblDataFiPrestec.Text;
                    dataRetorn = "--";
                }
                lblDataRetornPrestec.Text = dataRetorn;
                lblEstat.Text = estat;
                lblNumRenovacions.Text = prestecAct.numRenovacions.ToString();

                //Foto
                imageDoc.ImageUrl = "~/imagesDoc/sinfoto.jpg";
                if (String.IsNullOrEmpty(documentAct.imatge) == false)
                {
                    imageDoc.ImageUrl = "~/imagesDoc/" + documentAct.imatge;
                }

            }

            //Control retornat...
            if (prestecAct.retornat == true)
            {
                lblDataFiPrestecNwText.Text = " ";
                lblDataFiPrestecNw.Text = " ";
                Renovar.Enabled = false;
                missatge.Text = " ";
            }

            //Control numero renovacions...
            if (prestecAct.numRenovacions == 2)
            {
                Renovar.Enabled = false;
                missatge.Text = "No es podem fer més de 2 renovacions del document";
            }

        }

        
        //****************************************************************
        protected void Renovar_Click(object sender, EventArgs e)
        {
            //Calcular la nova data de retorn del document
            string dataFiPrestecNw = "";
            dataFiPrestecNw = clientWCF.calcularRenovacioPrestec(lblDataFiPrestec.Text, configuracioAct.diesPrestec);

            //Grabar la nova data de retorn del document 
            DateTime w_data = new DateTime();
            w_data = DateTime.Parse(dataFiPrestecNw);
            prestecAct.numRenovacions = prestecAct.numRenovacions + 1;
            prestecAct.dataFiPrestec = w_data;
            clientWCF.renovacioPrestecWeb(prestecAct);

            //Mostra dades per pantalla
            lblDataFiPrestecNw.Text = dataFiPrestecNw;
            missatge.Text = "Renovació realitzada correctament";
        }

        //****************************************************************
        protected void Tornar_Click(object sender, EventArgs e)
        {
            Response.Redirect("~/EspaiPersonal.aspx"); 
        }
    }
}